package com.esd.ucm.util;

import toolbox.db.*;

/**
 * @author SLiu
 *
 */
public class UCMTextUtil extends TextUtil {

	/**
	 * Constructor for UCMTextUtil.
	 */
	public UCMTextUtil() {
		super();
	}
	
	
	public String join(String[] dataElements, char delimiter, FieldSpec[] fieldSpecs, int[] indices)
	{
		if (dataElements==null) return null;
		int length = indices.length;
		
		StringBuffer buffer = new StringBuffer(100);		
		for (int i=0; i<length; i++)
		{
			int index = indices[i];
			int type = (fieldSpecs!=null && fieldSpecs[index]!=null)?fieldSpecs[index].getDataType():DataTypes.NUMBER;
			switch(type)
			{
				case DataTypes.STRING:
				case DataTypes.DATETIME:				
					if (stringQualifier!=null) buffer.append(stringQualifier);
					buffer.append(dataElements[index]);	
					if (stringQualifier!=null) buffer.append(stringQualifier);					
					break;
				default:
					buffer.append(dataElements[index]);				
				    break;				
			}
			if(i!=(length-1)) buffer.append(delimiter);
		}
		return buffer.toString();
	}
	
	

}
