/*
 * XChkCfgModifier.java
 *
 * Created on October 7, 2002, 11:00 AM
 */

package com.esd.util;

import java.io.*;
import java.util.Properties;
import java.util.ArrayList;
import com.gonetix.util.*;

/**
 *
 * @author  SLiu
 */
public class XChkCfgModifier {
    
    String[] paramlist = null;
    CmdLineOptions cmdOptions = null;
    
    /** Creates a new instance of XChkCfgModifier */
    public XChkCfgModifier(String[] args) 
    {        
        cmdOptions = CmdLineOptions.getCmdLineOptions(args);
        paramlist = cmdOptions.getOptions("params");       
    }
    
    public void replace() throws IOException
    {
        String input = cmdOptions.getOption("in");
        String content = readFile(input);
        content = StringFormater.format(content, paramlist);
        String output = cmdOptions.getOption("out");
         writeFile(output, content);
    }
    
    
    protected void writeFile(String path, String content) throws IOException
    {
        
        PrintWriter writer = new PrintWriter(new FileWriter(path));
        writer.println(content);       
        writer.flush();
        writer.close();             
    }
    
    protected String readFile(String path) throws IOException
    {
        StringWriter w = new StringWriter(2048);
        PrintWriter writer = new PrintWriter(w);
        BufferedReader br = new BufferedReader(new FileReader(path));
        String line = null;
        while ( (line=br.readLine())!=null){
            writer.println(line);
            writer.flush();
        }
        br.close();
        writer.flush();
        writer.close();
        return w.toString();        
    }
    
    
   protected static java.util.Properties getOptions(String[] args)
   {
       Properties prop = new Properties();
       for(int i=0; i<args.length; i++){
             if ( args[i].startsWith("-") && (i+1)<args.length && !args[i+1].startsWith("-")){
                 prop.setProperty(args[i].substring(1), args[i+1]);
             }
       }             
        return prop;
    }
    
    public static void main(String[] args)
    { 
        try{
            XChkCfgModifier modifier = new XChkCfgModifier(args);
            modifier.replace();
        }catch(Exception ex){
            ex.printStackTrace();
            usage();
            System.exit(1);
        }
        
    }
   
    public static void usage()
    {
        StringBuffer buffer = new StringBuffer(1024);
        buffer.append("\nUSAGE:\n");
        buffer.append("\tjava com.esd.util.XChkCfgModifier -in source_path -out output_path -params list_of_parameters.\n\n");
        System.out.println(buffer.toString());
    }
    
}
