package com.esd.util.conf;

import com.gonetix.util.CmdLineOptions;
import java.util.*;
import java.io.*;
import java.util.logging.*;
import java.util.regex.*;

/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public final class SearchNReplace {
	
	Logger logger = Logger.getLogger("com.esd.util.conf");
	
	private String pattern = null;
	private String replacement = null;
	private Vector files = null;
	private String dir = ".";
	private String outDir = ".";
	
	/**
	 * Constructor for SearchNReplace.
	 */
	public SearchNReplace() 
	{		
		files = new Vector();
	}


	public static void main(String[] args) 
	{
		SearchNReplace snr = new SearchNReplace();
		snr.start(args);	
	}
	
	
	public void start(String[] args)
	{
		CmdLineOptions options = CmdLineOptions.getCmdLineOptions(args);
		pattern = options.getOption("s");
		replacement = options.getOption("r");
		if ( pattern ==null || replacement == null) {
			usage();			
			System.exit(1);
		}
		String tdir = options.getOption("d");
		if ( tdir!=null && tdir.length()>0 ) dir = tdir;
		
		String odir = options.getOption("o");
		if ( odir!=null && odir.length()>0 ) outDir = odir;
		
		
		String[] fl = options.getOptions("f");	
		if (fl==null) {
			usage();			
			System.exit(1);
		}
		for(int i=0; i<fl.length; i++)	dir(fl[i]);		
		
		searchNreplace();	
		
	}
	
	
	
	private void searchNreplace()
	{
		Pattern p = Pattern.compile(pattern);
		
		String[] fileArray = new String[files.size()];
		files.copyInto(fileArray);
		
		for(int i=0; i<fileArray.length; i++)
		{			
				searchNreplace(p, fileArray[i]);			
		}		
	}
	
	
	
	
	private void searchNreplace(Pattern p, String filepath)
	{
		
		try{
			String content = FileUtil.readTextFile(filepath);
			Matcher m = null;
			boolean found = false;
			while ((m=p.matcher(content)).find())
			{
				found = true;			
				content = m.replaceFirst((this.replacement==null)?"":this.replacement);			
			}
			File od = new File(outDir);
			File f = new File(filepath);
			File of = new File(od, f.getName());
			FileWriter fw = new FileWriter(of);
			fw.write(content);
			fw.flush();
			fw.close();	
			if ( found ) System.out.println(of.getCanonicalPath());			
		}catch(Exception ex){
			logger.log(Level.WARNING, "Error at file : " + filepath, ex);
		}
		
	}
	
	
	private void dir(String pattern)
	{
		String[] list = pattern.split("\\s*,\\s*|\\s+");
		for(int i=0; i<list.length; i++)
		{
			if (list[i].indexOf("*")!=-1 || list[i].indexOf("?")!=-1 ){			
				try{
					File  wdir = new File(dir);
					String[] retlist = wdir.list(new FileMaskFilter(list[i]));
					for(int k=0; k<retlist.length; k++){
						files.addElement(FileUtil.getAbsolutePath(dir, retlist[k]));
					}
				}catch(Exception ex){
					logger.log(Level.WARNING, "Error at list template file.", ex);
				}
			}else{
				files.addElement(FileUtil.getAbsolutePath(dir, list[i]));
			}
			
		}
	}
	
	private void usage()
	{
		StringBuffer buffer = new StringBuffer(1024);
		buffer.append("\nUsage:\tjava com.esd.util.conf.SearchNReplace [options]...\n");
		buffer.append("\n\n");
		buffer.append("-s pattern\n");
		buffer.append("          patern to be matched\n");
		buffer.append("\n");
		buffer.append("-r replacement\n");
		buffer.append("          use to replace matched pattern.\n");
		buffer.append("\n");
		buffer.append("-f file1 [file2 file3...]\n");
		buffer.append("          a list files to be search and replaced\n");
		buffer.append("\n");
		buffer.append("-d working_directory\n");
		buffer.append("          a working directory\n");
		buffer.append("\n");
		buffer.append("-o output_directory\n");
		buffer.append("          a output directory, default to current directory.\n");
		buffer.append("\n");		
		System.out.println(buffer.toString());
	}
}
