/*
 * Task.java
 *
 * Created on August 13, 2002, 4:15 PM
 */

package com.esd.xml.parser;

import com.gonetix.framework.xmlEngine.*;
import com.gonetix.framework.dbpublish.*;
import com.gonetix.framework.util.*;
import com.gonetix.framework.xsltEngine.*;

import java.io.*;
import java.util.*;

/**
 *
 * @author  SLiu
 */
public class Task {
    
    private Properties taskProps;    
    private ArrayList paramList;
    private SQLStatement sqlStmt;
    
    public Task() {
        taskProps = new Properties();
        paramList = new ArrayList();
    }
    
    
    public void setSQLStatement(SQLStatement sqlStmt)
    {
        this.sqlStmt = sqlStmt;
    }  
    
    public Properties getProperties()
    {
        return this.taskProps;
    }
    
    public String getProperty(String key, String dfValue)
    {
        return taskProps.getProperty(key, dfValue);
    }
    
    public String getProperty(String key)
    {
        return taskProps.getProperty(key);
    }
    
    public void setProperty(String key, String value)
    { 
        this.taskProps.setProperty(key, value);
    } 
    
    public void addAll(Properties props)
    {
        this.taskProps.putAll(props);
    }
    
    public String getStatement()
    {
        if (this.sqlStmt!=null){
            return this.sqlStmt.getSatement();
        }else{
            return null;
        }
    }
    public String getStatementId()
    {
        if (this.sqlStmt!=null){
            return this.sqlStmt.getId();
        }else{
            return null;
        }
    }
    
    public int getStatementType()
    {
        if (this.sqlStmt!=null){
            return this.sqlStmt.getStatementType();
        }else{
            return SQLStatement.UNKNOW_STATEMENT;
        }
    }
    
    public void addParam(Parameter param)
    {
         paramList.add(param);  
    }
    
    public void addAllParam(Collection params)
    {
         paramList.addAll(params);
    }
    
    public Parameter[] getParams()
    {
        Parameter[] ps = new Parameter[paramList.size()];
        paramList.toArray(ps);        
        return ps;
    }
    
}
