package com.esdi;

/**
 * Standard application return codes that Aexeo server applications should return.  All
 * server apps should use these.
 *
 * Where defined, these correspond to known Autosys error codes and are used by Autosys
 * for job control.
 */
public interface AexeoReturnCodes {

    public static final int
        RETURN_OK = 0,

    // Warnings
        RETURN_SAFE_MODE = 1,       // application ran in 'safe-mode' without updating DB
        RETURN_PRINTED_USAGE = 2,   // application printed usage info only

    // Remaining values up to RETURN_INCOMPLETE available for application-specific warnings

    // Errors
        RETURN_INCOMPLETE = 6,                  // application did not finish as expected; this is the default application return
        RETURN_INVALID_ARGUMENTS = 7,           // application started with invalid arguments
        RETURN_DATABASE_CONNECTION_FAILURE = 8, // could not connect to DB
        RETURN_USER_AUTHORIZATION_FAILURE = 9,  // user authorization stopped application from running
        RETURN_IO_EXCEPTION = 10,               // io exception stopped application from running
        RETURN_EXCEPTION = 11,                  // exception in program stopped application
        RETURN_CONFIGURATION_FAILURE = 12;      // bad or missing configuration information, either in properties file or database

    // remaining values available for application-specific errors

}
