/*
 * BaseCorbaServer.java
 *
 * This will be used to provide basic services to all Corba Applications.
 *
 * Created on July 22, 2002, 2:51 PM
 */

package com.esdi.corba;

import org.omg.PortableServer.*;

import java.sql.*;

import tudor.sql.*;

/**
 *
 * @author  dlattimoregay
 */
public class BaseCorbaServer {
    protected Connection c = null;
    
    protected void initDBConnection(String dbName, String username, String password) throws Exception {
        c = TuJDBC.getDbConnection(dbName, "JavaTudorDefault", username, password);
    };
    
    protected void saveIORToFile(long appId, String IOR, String filename) throws Exception {
        try {
            java.io.FileWriter writer = new java.io.FileWriter(filename);
            writer.write( IOR );
            writer.close();
            
            System.out.println( "Written IOR to file " + filename );
        } catch ( Exception ex ) {
            ex.printStackTrace();
        } catch( Error er ) {
            er.printStackTrace();
        } finally {
        }
    };
    
    /**
     * Save the IOR somewhere by App Id
     */
    protected void saveIOR(long appId, String IOR) throws Exception {
        TuResultSet res = TuJDBC.querySINGLE(c, "DELETE FROM common.dbo.ior WHERE tudor_app_id="+appId);
        int index = 0;
        int lineNo = 0;
        int length = IOR.length();
        System.out.println(IOR);
        String sIOR;
        while (true)  {
            if (index > length) {
                break;
            }
            if (250+index > length) {
                sIOR = IOR.substring(index, length);
            } else  {
                sIOR = IOR.substring(index, 250+index);
            }
            System.out.println(sIOR);
            TuJDBC.querySINGLE(c, "INSERT common.dbo.ior (tudor_app_id, line_no, ior_string) VALUES ("+
            appId+","+lineNo+",'"+sIOR+"')");
            index += 250;
            lineNo++;
        }
    }
    
    protected void initORB() {
        if (System.getProperties().get("ORBagentPort") == null) {
            System.getProperties().put("ORBagentPort", "14000");
        }
        if (System.getProperties().get("org.omg.CORBA.ORBClass") == null) {
            System.getProperties().put("org.omg.CORBA.ORBClass", "com.inprise.vbroker.orb.ORB");
        }
        if (System.getProperties().get("org.omg.CORBA.ORBSingletonClass") == null) {
            System.getProperties().put("org.omg.CORBA.ORBSingletonClass", "com.inprise.vbroker.orb.ORB");
        }
    }
    
    static protected String fileSeparator = new String();
    
    static {
        fileSeparator = System.getProperty("file.separator");
    }
};