package com.esdi.sql;


import java.util.Date;
import java.text.SimpleDateFormat;


/**
 * Class with static utility SQL methods.
 *
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Emphasis Software Development</p>
 * @author Bill Kelemen
 * @version 1.0
 */
public class ESDSQLUtil {

    ////////////////////////////////////////////////////////////////////////////
    // attributes
    ////////////////////////////////////////////////////////////////////////////

    private static final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

    ////////////////////////////////////////////////////////////////////////////
    // operations
    ////////////////////////////////////////////////////////////////////////////

    /**
     * Utility function to convert a Date object into a Sybase friendly String
     * representation. Code copied from tudor.sql.util.TuSQLMetaData.
     * @param date
     * @return
     */
    public static String makeDateString(Date date) {
        return (sdf.format(date));
    }

    /**
     * Utility method to escape a String that contains a single quote.
     * @param s
     * @return
     */
    public static String escape(String s) {
        if (s.indexOf('\'') == -1) {
            return (s);
        } else {
            return (s.replaceAll("'", "''"));
        }
    }

    ////////////////////////////////////////////////////////////////////////////
    // for testing only
    ////////////////////////////////////////////////////////////////////////////

    public static void main(String[] args) {

        String s = "I've gone home's";
        System.out.println("Test escape: SELECT * FROM PLACE WHERE txt='"+escape(s)+"'");
    }

}
