package com.esdi.util;

/**
 * <p>Description: Dividends are keyed by their CUSIP and the sequence number.
 *
 * <p>Copyright: Copyright (c) Emphasis Software Development 2002</p>
 * @author Martin Buis
 * @version 1.0
 */

public class IDCDomesticCAKeyScheme
implements CAParserKeyScheme {

    public IDCDomesticCAKeyScheme() {
    }

    /**
     * Return true if lineOrKey is the first line of a record
     */
    public boolean isNewRecord(String priorKey, String lineOrKey) {
        if (buildKey(lineOrKey).equals(priorKey)) {
            return ! IDCDomesticCATypeScheme.buildKey(lineOrKey).equals("92");  // 92 is continuation, all others are new action
        } else {
            return priorKey != null;
        }
    }

    /**
     * Return the key according to the type of line
     */
    public String getKey(String line) {
        return buildKey(line);
    }

    /////////////////////////////////////////////////////////////////////////////////
    // IMPLEMENTATION
    /////////////////////////////////////////////////////////////////////////////////

    private String buildKey(String line) {
        String id = line.substring(0,8);   // CUSIP
//        String type = line.substring(19,22);    // SEQUENCE NUMBER
        return id; // + type;
    }

}