package com.esdi.util;

/**
 * <p>Description: IDC Domestic records have a record type deteremined by the file name
 *
 * <p>Copyright: Copyright (c) Emphasis Software Development 2002</p>
 * @author Martin Buis
 * @version 1.0
 */

public class IDCDomesticCATypeScheme implements ICustomParserKeyScheme {

    public IDCDomesticCATypeScheme() {
    }


    /**
     * Return the key according to the type of line
     */
    public static String buildKey(String line) {
        String type = line.substring(8,9);
        if (type.equals(" ")) {
            return "U";     // DOS won't allow property files named " .properties" so map to IDC's alternative name
        } else if (type.equals("9")) {
            String continuation = line.substring(22,23);
            return type + continuation;
        } else {
            return type;
        }
    }

    public String getKey(String line) {
        return buildKey(line);
    }

}