/*
 * Timer.java
 *
 * Created on April 24, 2002, 4:38 PM
 */

package com.gn.util;

/**
 *
 * @author  dlattimoregay
 */
public class Timer {
    
    long startTime = 0;
    long endTime = 0;
    
    /** Creates a new instance of Timer */
    private Timer() {
    }

    /**
     */
    public static Timer newInstance() {
        return new Timer();
    }
    
    /**
     * Starts the timer
     */
    public void start() { 
        startTime = System.currentTimeMillis(); 
    }
    
    /*
     * Stops the timer
     */
    public void stop() { 
        endTime = System.currentTimeMillis(); 
    }
    
    /**
     * report the current ellapsed time since the call to start(), this does not
     * stop the timer from running, this will allow acumaltive times
     */
    public long accumalitive() { 
        return System.currentTimeMillis() - startTime; 
    }
    
    /**
     * 
     */
    public long reset() { 
        endTime = System.currentTimeMillis(); 
        long l = endTime - startTime; 
        start(); 
        return l;
    }
    
    
    /**
     * this returns the actuall elapsed time between calls to start() and stop()
     */
    public long elapsed() { 
        return endTime - startTime; 
    }
    
    
    /**
     */
    public static void main(String[] args) {
        Timer t = Timer.newInstance();
        t.start();
        try {
            Thread.sleep(1000);
        } catch ( Exception ex ) {
        } finally {
            System.out.println ( t.elapsed() );
        }
    }
}
