package com.gonetix.automation;

import java.util.*;
import com.gonetix.properties.RegExProperties;

/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ActionRegistry extends RegExProperties
{
	
	private final static Hashtable registries = new Hashtable();
	private final static String DEFAULT_NAME = "DEFAULT";
	
	static{
		ActionRegistry defaultRegistry = new ActionRegistry();		
		registries.put(DEFAULT_NAME, defaultRegistry);		
	}
	
	/**
	 * Constructor for ActionRegistry.
	 */
	protected ActionRegistry() {
		this(null);		
	}
	
	protected ActionRegistry(String path) {
		super();		
	}
	
	
		
	public synchronized static ActionRegistry getActionRegistry(String path)
	{
		if ( path == null ) path = DEFAULT_NAME;
		ActionRegistry registry = (ActionRegistry)registries.get(path);
		if (registry==null){
			registry = new ActionRegistry(path);
			registry.putAll((ActionRegistry)registries.get(DEFAULT_NAME));
			registries.put(path, registry);
		}		
		return registry;
	}
	
	
	public Action getActionInstance(String actionName) throws NoActionClassDefinedException
	{
		Action action = null;
		try{
			String className = this.getActionClassName(actionName);
			action = (Action)Class.forName(className).newInstance();			
		}catch(Exception ex){			
			throw new NoActionClassDefinedException("No Action class found exception : " + actionName, ex);
		}		
		return action;		
	}
	
	public String getActionClassName(String actionName)
	{
		return this.getProperty(actionName);
	}
	
	public void register(String aciotnName, String className)
	{
		this.setProperty(aciotnName, className);
	}
	
	public String unregister(String actionName)
	{
		return (String)remove(actionName);
	}
	
	public boolean isActionDefined(String actionName)
	{
		return (this.getProperty(actionName)!=null);	
	}
}
