package com.gonetix.automation;

import java.util.*;

/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ActionWrapper {

	private String actionName = null;
	private Properties actionProperties = null;
	private Vector children = null;
	private String text = null;
	
	/**
	 * Constructor for ActionWrapper.
	 */
	public ActionWrapper() {
		children = new Vector();
	}
	
	public ActionWrapper(String actionName) 
	{
		this.actionName = actionName;
	}
	
	
	public ActionWrapper createChild(String name)
	{
		ActionWrapper wrapper = new ActionWrapper(name);
		children.add(wrapper);
		return wrapper;
	}
	
	public boolean hasSubAction()
	{
		return (children.size() > 0 );
	}
	
	
	public ActionWrapper[] children()
	{
		ActionWrapper[] cs = new ActionWrapper[children.size()];
		children.copyInto(cs);
		return cs;
	}
	
	/**
	 * Returns the actionName.
	 * @return String
	 */
	public String getActionName() {
		return actionName;
	}

	/**
	 * Returns the actionProperties.
	 * @return Properties
	 */
	public Properties getActionProperties() {
		return actionProperties;
	}

	/**
	 * Sets the actionName.
	 * @param actionName The actionName to set
	 */
	public void setActionName(String actionName) {
		this.actionName = actionName;
	}

	public void addProperties(Properties prop)
	{
		if ( this.actionProperties!=null){
			actionProperties.putAll(prop);
		}else{
			this.actionProperties = prop;
		}
	}
	
	/**
	 * Sets the actionProperties.
	 * @param actionProperties The actionProperties to set
	 */
	public void setActionProperties(Properties actionProperties) {
		this.actionProperties = actionProperties;
	}

	/**
	 * Returns the text.
	 * @return String
	 */
	public String getText() {
		return text;
	}

	/**
	 * Sets the text.
	 * @param text The text to set
	 */
	public void setText(String text) {
		this.text = text;
	}

}
