package com.gonetix.automation;


import java.util.*;

/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public final class Project 
{
	
	private Properties globalProperties = null;
	private Properties cmdLineProperties = null;
	private String actionRegistryLocation = null;
	private ActionRegistry actionRegistry = null;	
	
	private Hashtable taskList = null;
	
	
	public void performTask(String id) throws ActionExecutionException
	{
		actionRegistry = ActionRegistry.getActionRegistry(actionRegistryLocation);
		try{
			Task task = (Task)taskList.get(id);
			if (task==null)throw new ActionExecutionException("Task not found exception. task : " + id);
			String[] ids = task.getDependents();
			for(int i=0; i<ids.length; i++){
				performTask(ids[i]);	
			}
			task.perform();			
		}catch(Exception ex){
			throw new ActionExecutionException("Task execution exception.", ex);
		}
	}		
	
	
	public Task newTask(String id)
	{
		Task task = new Task(this);
		task.setId(id);
		taskList.put(id, task);		
		return task;
	}	
		
	
	/**
	 * Returns the cmdLineProperties.
	 * @return Properties
	 */
	public Properties getCmdLineProperties() {
		return cmdLineProperties;
	}

	/**
	 * Returns the globalProperties.
	 * @return Properties
	 */
	public Properties getGlobalProperties() {
		return globalProperties;
	}

	/**
	 * Sets the cmdLineProperties.
	 * @param cmdLineProperties The cmdLineProperties to set
	 */
	public void setCmdLineProperties(Properties cmdLineProperties) {
		this.cmdLineProperties = cmdLineProperties;
	}

	/**
	 * Sets the globalProperties.
	 * @param globalProperties The globalProperties to set
	 */
	public void setGlobalProperties(Properties globalProperties) {
		this.globalProperties = globalProperties;
	}

	/**
	 * Returns the actionRegistry.
	 * @return ActionRegistry
	 */
	public ActionRegistry getActionRegistry() {
		return actionRegistry;
	}

	/**
	 * Returns the actionRegistryLocation.
	 * @return String
	 */
	public String getActionRegistryLocation() {
		return actionRegistryLocation;
	}

	/**
	 * Sets the actionRegistryLocation.
	 * @param actionRegistryLocation The actionRegistryLocation to set
	 */
	public void setActionRegistryLocation(String actionRegistryLocation) {
		this.actionRegistryLocation = actionRegistryLocation;
	}

}
