/*
 * SQLStatementHandler.java
 *
 * Created on August 22, 2002, 2:01 PM
 */

package com.gonetix.common;


import java.io.*;
import java.util.*;
import com.gonetix.util.*;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.FactoryConfigurationError;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
/**
 *
 * @author  SLiu
 */
public final class SQLStatementHandler extends DefaultHandler{
    
    private ChainableHandler parent;
    private SQLStatement sqlStmt;
    private String tagName;
    private StringBuffer value;
    
    /** Creates a new instance of SQLStatementHandler */
    public SQLStatementHandler(ChainableHandler parent, SQLStatement sqlStmt) {
        super();
        this.parent = parent;
        this.sqlStmt = sqlStmt;
        value = new StringBuffer(100); 
    }
    
    public void init(String tagName, Attributes atts)
    {
        this.tagName = tagName;        
    }
    
    public void characters(char[] ch, int start, int length)
    throws SAXException 
    {       
        String content = (new String(ch, start, length));
        value.append(content);
    }
    
    public void endElement(String namespaceURI, String localName, String qName)
    throws SAXException 
    {
        if (qName.equals(tagName)){
            String stmt = value.toString();
            if(stmt.length()>0){            
                stmt=StringUtil.decodeXMLEntity(stmt);
                sqlStmt.setStatement(StringUtil.strip(stmt.trim()));
            }
            parent.setContentHandler(parent);
            value = null;
        }        
    }
    
}
