/*
 * SQLTypeParser.java
 *
 * Created on August 23, 2002, 3:41 PM
 */

package com.gonetix.common;

import java.sql.Types;
import java.sql.*;

/**
 *
 * @author  SLiu
 */
public class SQLTypeParser {
    
    /** Creates a new instance of SQLTypeParser */
    public SQLTypeParser() {
    }
    
    
    public static int getSqlType(String typeString) throws SQLException
    {   
        int type = Types.OTHER;
        try{
            type = Integer.valueOf(typeString).intValue();            
        }catch(Exception ex){
            ;
        }
        if ( type != Types.OTHER){
            return type;
        }else        
        try{
            typeString = typeString.toUpperCase();
            if (typeString.equals("VARCHAR")){
                type = Types.VARCHAR;
            }else if (typeString.equals("CHAR")){                
                type = Types.CHAR;
            }else if (typeString.equals("LONGVARCHAR")){
                 type = Types.LONGVARCHAR;  
            }else if (typeString.equals("INT") || typeString.equals("INTEGER")){
                 type = Types.INTEGER;
            }else if (typeString.equals("BIGINT") || typeString.equals("LONG")){
                 type = Types.BIGINT;
            }else if (typeString.equals("BIT") || typeString.equals("BOOLEAN")){
                 type = Types.BIT;
            }else if (typeString.equals("DATE") || typeString.equals("DATETIME")){
                 type = Types.DATE;
            }else if (typeString.equals("DECIMAL") || typeString.equals("NUMBER")){
                 type = Types.DECIMAL;
            }else if (typeString.equals("DOUBLE")){
                 type = Types.DOUBLE;
            }else if (typeString.equals("FLOAT")){
                 type = Types.FLOAT;
            }else if (typeString.equals("NUMERIC")){
                 type = Types.NUMERIC;
            }else if (typeString.equals("REAL")){
                 type = Types.REAL;
            }else if (typeString.equals("SMALLINT")){
                 type = Types.SMALLINT;
            }else if (typeString.equals("TIME")){
                 type = Types.TIME;
            }else if (typeString.equals("TIMESTAMP")){
                 type = Types.TIMESTAMP;
            }else if (typeString.equals("TINYINT")){
                 type = Types.TINYINT;
            }else{
                type = Types.OTHER;
            }            
        }catch(Exception e){
            throw new  SQLException("FATAL: Invalid SQL Type String");  
        }
        return type;
    }
    
}
