package com.gonetix.diagnostic;

import java.io.PrintStream;

/**
 * @author SLiu
 *
 */
public final class PerformanceWatcher {

	private final String MSG1 = " time elapses ";
	private final String MSG2 = " ms.";
	
	private String watchId = null;
	private long startTime = 0;
	private PrintStream out = null;
	
	/**
	 * Constructor for PerformanceWatcher.
	 */
	public PerformanceWatcher(String id) 
	{
		super();
		this.watchId = id;
		this.startTime = System.currentTimeMillis();
		this.out = System.out;
	}
	
	public void startWatch()
	{
		this.startTime = System.currentTimeMillis();
		out.print(watchId);
		out.print(" started at ");
		out.print(new java.util.Date(startTime).toString());
		out.print(".");
		out.flush();
	}
	
	
	public void setWatchPoint()
	{
		out.print(watchId);
		out.print(MSG1);
		out.print(System.currentTimeMillis() - startTime);
		out.print(MSG2);
		out.flush();
	}
	
	public void setWatchPoint(String cmsg)
	{
		out.print(watchId);
		out.print(" [");	
		out.print(cmsg);
		out.print("] ");	
		out.print(MSG1);
		out.print(System.currentTimeMillis() - startTime);
		out.print(MSG2);
		out.flush();
	}
	
	
	public void reset()
	{
		this.startTime = System.currentTimeMillis();
		out.print(watchId);
		out.print(" reset at ");
		out.print(new java.util.Date(startTime).toString());
		out.print(".");
		out.flush();
	}

	/**
	 * Returns the out.
	 * @return PrintStream
	 */
	public PrintStream getOut() {
		return out;
	}

	/**
	 * Sets the out.
	 * @param out The out to set
	 */
	public void setOut(PrintStream out) {
		this.out = out;
	}

}
