package com.gonetix.framework.dbengine;

import java.util.*;
import java.text.*;

public class DBDateFormater 
{
  public static final String DATEFORMAT = "dateFormat";
  public static final String TIMEFORMAT = "timeFormat";
  public static final String TIMESTAMPFORMAT = "timestampFormat";
  
  private final String dateFormatString = "yyyy-MM-dd HH:mm:ss";
  private final String timeFormatString = "HH:mm:ss";
  private final String tsFormatString = "yyyy-MM-dd HH:mm:ss.S";

  private SimpleDateFormat dateFormat = null;
  private SimpleDateFormat timeFormat = null;
  private SimpleDateFormat timestampFormat = null;

  public DBDateFormater(Properties prop)
  {
      boolean useDefault = false;
      if (prop == null ) useDefault = true;
      String pstr = null;
      if (useDefault || (pstr=prop.getProperty(DATEFORMAT))==null){
            dateFormat = new SimpleDateFormat(dateFormatString);
      }else{
            dateFormat = new SimpleDateFormat(pstr);
      }

      if (useDefault || (pstr=prop.getProperty(timeFormatString))==null){
            timeFormat = new SimpleDateFormat(timeFormatString);
      }else{
            timeFormat = new SimpleDateFormat(pstr);
      }

      if (useDefault || (pstr=prop.getProperty(TIMESTAMPFORMAT))==null){
            timestampFormat = new SimpleDateFormat(tsFormatString);
      }else{
            timestampFormat = new SimpleDateFormat(pstr);
      }
  }

  public DBDateFormater()
  {
      this(null);
  }


  public String formatDate(java.util.Date date)
  {
      return dateFormat.format(date);
  }

  public String formatTime(java.util.Date date)
  {
      return timeFormat.format(date);
  }

  public String formatTimestamp(java.util.Date date)
  {
      return timestampFormat.format(date);
  }

  public void setDateFormat(SimpleDateFormat format)
  {
        this.dateFormat = format;
  }

  public SimpleDateFormat getDateFormat()
  {
        return this.dateFormat;
  }

  public void setTimeFormat(SimpleDateFormat format)
  {
        this.timeFormat = format;
  }

  public SimpleDateFormat getTimeFormat()
  {
        return this.timeFormat;
  }

  public void setTimestampFormat(SimpleDateFormat format)
  {
        this.timestampFormat = format;
  }

  public SimpleDateFormat getTimestampFormat()
  {
        return this.timestampFormat;
  }
  
}