package com.gonetix.framework.dbpublish;

import java.io.*;
import java.util.*;
import java.sql.*;


/**
 * @author SLiu
 *
 */
public class CSVWriter2 extends CSVWriter implements IPublishWriter2 
{
	
	/**
	 * @see com.gonetix.framework.dbpublish.IPublishWriter2#write(java.sql.Statement, boolean)
	 */
	public void write(Statement stmt, boolean hasFirstResult)
	throws IOException 
	{
		
		int b = -1;
        try{
            while ( hasFirstResult || (b=stmt.getUpdateCount())!=-1 ){            
                  if ( hasFirstResult ){                  
                     ResultSet rs = stmt.getResultSet();
                     write(rs);
                     if(applyTrailerAll) 
                     {
                     	this.printTrailer();
                     	resetRowCount();  
                     }           
                  }else if (b!=-1){                  
                     //pw.write("\nexecuteUpdate: ");
                     //pw.write("Total "); 
                     //pw.write(b); 
                     //pw.write(" rows affected.\n");
                     b = -1;
                  }else{
                     //pw.write("\nexecuteDDL: ");                 
                     //pw.write("This command does not return anything.\n"); 
                 }
                  hasFirstResult = stmt.getMoreResults();                  
            }
            
            if(!applyTrailerAll) this.printTrailer();            
        }catch(SQLException ex){
            throw new IOException(ex.toString());
        }
	}

}
