/*
 * TransformWriter.java
 *
 * Created on August 14, 2002, 2:52 PM
 */

package com.gonetix.framework.dbpublish;


import com.gonetix.framework.xsltEngine.XSLTTransformer;
import java.io.*;
import java.util.*;
import java.sql.*;
/**
 *
 * @author  SLiu
 */
public class TransformWriter extends PublishWriter {
    
    /** Creates a new instance of TransformWriter */
    
    XMLBuilder xmlBuilder = null;
    XSLTTransformer xsltTranformer = null;
    
    public TransformWriter() {
        super();
        xmlBuilder = new XMLBuilder();
        xsltTranformer = new XSLTTransformer();
    }
    
    public TransformWriter(OutputStream out){
        super(out); 
        xmlBuilder = new XMLBuilder();
        xsltTranformer = new XSLTTransformer();
    }
    
    public void write(java.sql.ResultSet rs) throws java.io.IOException 
    {
        StringWriter sw;
        StringReader sr;
        try{
            sw = new StringWriter();
            xmlBuilder.buildXML(sw, rs);
            sr = new StringReader(sw.toString());
            xsltTranformer.transform(sr);
        }catch(Exception e){
            throw new IOException("FATAL: faile write to output. " + e.toString());
        }
    }  
    
    
     public void initWriter(java.util.Properties prop)
     {
        super.initWriter(prop);
        xmlBuilder.initWriter(prop);
        String xslfile = prop.getProperty("styleSheet");
        if ( xslfile == null){
            System.err.println("FATAL: XSL Style sheet is required for transformation.");
            System.exit(3);
        }
        try{
            xsltTranformer.init(xslfile);
        }catch(Exception e){
            System.err.println("FATAL: Failed to initialize XSL style sheet. " + e.toString());
            System.exit(3);
        }
        
     }
    
    public void setOutput(String filepath) throws IOException
    {        
         try{
            xsltTranformer.setOutput(new FileOutputStream(filepath));
        }catch(Exception e){
            throw new IOException("FATAL: Failed to open output file. " + e.toString());
        }
    }
    
    
    public void close() throws IOException
    { 
        ;
    }
}
