package com.gonetix.framework.dbpublish;

import java.io.*;
import java.util.*;
import java.sql.*;

/**
 * @author SLiu
 *
 */
public class XLSWriter2 extends XLSWriter implements IPublishWriter2 {

	/**
	 * Constructor for XLSWriter2.
	 * @param out
	 */
	public XLSWriter2(OutputStream out) {
		super(out);
	}

	/**
	 * Constructor for XLSWriter2.
	 */
	public XLSWriter2() {
		super();
	}

	/**
	 * @see com.gonetix.framework.dbpublish.IPublishWriter2#write(java.sql.Statement, boolean)
	 */
	public void write(Statement stmt, boolean hasFirstResult)
		throws IOException 
	{
		int b = -1;
        try{
            while ( hasFirstResult || (b=stmt.getUpdateCount())!=-1 ){            
                  if ( hasFirstResult ){                  
                     ResultSet rs = stmt.getResultSet();
                     write(rs);             
                  }else if (b!=-1){
                     b = -1;
                  }
                  hasFirstResult = stmt.getMoreResults();
            }
        }catch(SQLException ex){
            throw new IOException(ex.toString());
        }
	}

}
