/*
 * XMLBuilder.java
 *
 * Created on August 8, 2002, 5:55 PM
 */

package com.gonetix.framework.dbpublish;


import java.io.*;
import java.util.*;
import java.sql.*;

import com.gonetix.framework.util.StringUtil;

/**
 *
 * @author  SLiu
 */
public class XMLBuilder extends XMLWriter {    
      
    /** Creates a new instance of XMLBuilder */
    public XMLBuilder() {
        super();
    }    
    
    public String buildXML(ResultSet rs) throws IOException
    {
        StringWriter sw = new StringWriter();        
        try{
            ResultSetMetaData rsmd = rs.getMetaData();
            int colcount = rsmd.getColumnCount();
            int[] colType = getColumnTypes(rsmd);            
            String[] colnames = getColumnNames(rsmd);            
            String value = null;            
            sw.write(ELSTART); sw.write(xmlRootName); sw.write(ELGT);
            while(rs!=null && rs.next()){
                switch( xmlStyle) {                    
                    case STYLE_ATTRIBUTE:
                        writeStyleAttribute(sw, colcount, colnames, colType,rs);
                    break;
                    case  STYLE_ELEMENT:                        
                    default:
                        writeStyleElement(sw, colcount, colnames, colType, rs);
                        break;
                }                            
            }            
            sw.write(ENDSTART); sw.write(xmlRootName);sw.write(ELGT);
        }catch(Exception ex){
            throw new IOException(ex.getMessage());
        }
        return sw.toString();
    }    
    
    public void biuldXmlRow(Writer w, int colcount, String[] colnames, int[] colType, String rowName,ResultSet rs)  
    throws SQLException, IOException
    {
        String value = null;       
         w.write(ELSTART); w.write(rowName); w.write(ELGT); 
        for(int i=0; i<colcount; i++){
            w.write(ELSTART); w.write(colnames[i]); w.write(ELGT);            
            value = getString(rs, i+1, colType[i]);
            w.write((value!=null)?StringUtil.encodeXMLEntity(value):"");
             w.write(ENDSTART); w.write(colnames[i]); w.write(ELGT); 
         } 
         w.write(ENDSTART); w.write(rowName); w.write(ELGT);         
    }
    
    public void buildXML(Writer w, ResultSet rs) throws IOException
    {
        BufferedWriter sw =new BufferedWriter(w);              
        try{
            ResultSetMetaData rsmd = rs.getMetaData();
            int colcount = rsmd.getColumnCount();
            int[] colType = getColumnTypes(rsmd);            
            String[] colnames = getColumnNames(rsmd);
            
            String value = null;            
            sw.write(ELSTART); sw.write(xmlRootName); sw.write(ELGT);
            while(rs!=null && rs.next()){
                switch( xmlStyle) {                    
                    case STYLE_ATTRIBUTE:
                        writeStyleAttribute(sw, colcount, colnames,colType, rs);
                    break;
                    case  STYLE_ELEMENT:                        
                    default:
                        writeStyleElement(sw, colcount, colnames,colType, rs);
                        break;
                }                            
            }            
            sw.write(ENDSTART); sw.write(xmlRootName);sw.write(ELGT);
            sw.flush();
        }catch(Exception ex){
            throw new IOException(ex.getMessage());
        }
        sw.flush();       
    }
    
}
