package com.gonetix.framework.textengine;

/**
 * @author Sunny Liu
 * This class defines text data file's field spec
 */
public final class FieldSpec {

	
	private String name = null;
	private String type = null;
	private int startAt = -1;
	private int length = 0;
	private String tableName = null;
	private String format = null;	
	
	/**
	 * Constructor for FileSpec.
	 */
	public FieldSpec() {
		super();
	}

	/**
	 * Returns the format.
	 * @return String
	 */
	public String getFormat() {
		return format;
	}

	/**
	 * Returns the length.
	 * @return int
	 */
	public int getLength() {
		return length;
	}

	/**
	 * Returns the name.
	 * @return String
	 */
	public String getName() {
		return name;
	}

	/**
	 * Returns the startAt.
	 * @return int
	 */
	public int getStartAt() {
		return startAt;
	}

	/**
	 * Returns the tableName.
	 * @return String
	 */
	public String getTableName() {
		return tableName;
	}

	/**
	 * Returns the type.
	 * @return String
	 */
	public String getType() {
		return type;
	}

	/**
	 * Sets the format.
	 * @param format The format to set
	 */
	public void setFormat(String format) {
		this.format = format;
	}

	/**
	 * Sets the length.
	 * @param length The length to set
	 */
	public void setLength(int length) {
		this.length = length;
	}

	/**
	 * Sets the name.
	 * @param name The name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Sets the startAt.
	 * @param startAt The startAt to set
	 */
	public void setStartAt(int startAt) {
		this.startAt = startAt;
	}

	/**
	 * Sets the tableName.
	 * @param tableName The tableName to set
	 */
	public void setTableName(String tableName) {
		this.tableName = tableName;
	}

	/**
	 * Sets the type.
	 * @param type The type to set
	 */
	public void setType(String type) {
		this.type = type;
	}

}
