package com.gonetix.framework.textengine;

/**
 * @author SLiu
 *
 */
import java.util.*;


public class FileSpec 
{
	
	public static final int FILE_TYPE_DELIMITED = 0;
	public static final int FILE_TYPE_FIXED_LENGTH = 1;
	public static final int FILE_TYPE_XML = 2;
	public static final int FILE_TYPE_XLS = 3;
	public static final int FILE_TYPE_DELIMITED_QUOTED = 4;
	public static final int FILE_TYPE_UNKNOW = 5;
	
	SectionSpec headerSpec = null;
	SectionSpec contentSpec = null;
	SectionSpec trailerSpec = null;
	Properties fileGlobalProperty = null;
	
	private int fileType = FILE_TYPE_DELIMITED;
	
	
	public FileSpec() {
		fileGlobalProperty = new Properties();
	}
	
	/**
	 * Method addProperty.
	 * @param key
	 * @param value
	 */
	public void addProperty(String key, String value)
	{
		fileGlobalProperty.setProperty(key, value);
	}
	
	/**
	 * Method addProperties.
	 * @param prop
	 */
	public void addProperties(Map prop)
	{
		fileGlobalProperty.putAll(prop);
	}

	/**
	 * Returns the fileGlobalProperty.
	 * @return Properties
	 */
	public Properties getFileGlobalProperty() {
		return fileGlobalProperty;
	}

	/**
	 * Returns the contentSpec.
	 * @return SectionSpec
	 */
	public SectionSpec getContentSpec() {
		return contentSpec;
	}

	/**
	 * Returns the headerSpec.
	 * @return SectionSpec
	 */
	public SectionSpec getHeaderSpec() {
		return headerSpec;
	}

	/**
	 * Returns the trailerSpec.
	 * @return SectionSpec
	 */
	public SectionSpec getTrailerSpec() {
		return trailerSpec;
	}

	/**
	 * Sets the contentSpec.
	 * @param contentSpec The contentSpec to set
	 */
	public void setContentSpec(SectionSpec contentSpec) {
		this.contentSpec = contentSpec;
	}

	/**
	 * Sets the headerSpec.
	 * @param headerSpec The headerSpec to set
	 */
	public void setHeaderSpec(SectionSpec headerSpec) {
		this.headerSpec = headerSpec;
	}

	/**
	 * Sets the trailerSpec.
	 * @param trailerSpec The trailerSpec to set
	 */
	public void setTrailerSpec(SectionSpec trailerSpec) {
		this.trailerSpec = trailerSpec;
	}

	/**
	 * Returns the fileType.
	 * @return int
	 */
	public int getFileType() {
		return fileType;
	}

	/**
	 * Sets the fileType.
	 * @param fileType The fileType to set
	 */
	public void setFileType(int fileType) {
		this.fileType = fileType;
	}

}
