package com.gonetix.framework.textengine;

/**
 * @author SLiu
 *
 */
import java.util.*;

public final class SectionHandlerSpec {

	
	protected String className = null;
	protected Properties sectionProp = null;
	
	/**
	 * Constructor for SectionHandlerSpec.
	 */
	public SectionHandlerSpec(String className) 
	{
		this.className = className;
		sectionProp = new Properties();
	}	
	
	
	
	/**
	 * Method addProperty.
	 * @param key
	 * @param value
	 */
	public void addProperty(String key, String value)
	{
		sectionProp.setProperty(key, value);
	}
	
	/**
	 * Method addProperties.
	 * @param prop
	 */
	public void addProperties(Map prop)
	{
		sectionProp.putAll(prop);
	}

	/**
	 * Returns the className.
	 * @return String
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * Returns the sectionProp.
	 * @return Properties
	 */
	public Properties getSectionProp() {
		return sectionProp;
	}

	/**
	 * Sets the className.
	 * @param className The className to set
	 */
	public void setClassName(String className) {
		this.className = className;
	}

}
