package com.gonetix.framework.textengine;

/**
 * @author SLiu
 *
 * This class defines each section in data file
 */
public class SectionSpec 
{

	public final static int SECTION_TEXT_TYPE_DELIMITED = 0;
	public final static int SECTION_TEXT_TYPE_FIXED_LENGTH = 1;
	public final static int SECTION_TEXT_TYPE_XML = 2;
	
	private FieldSpec[] fieldSpecs = null;
	private SectionHandlerSpec[] handlerSpecs = null;
	
	private String delimiter = null;
	private int type = 0;
	private int rowcount = 0;
	
	/**
	 * Constructor for SectionSpec.
	 */
	public SectionSpec() {
		super();
	}

	/**
	 * Returns the delimiter.
	 * @return String
	 */
	public String getDelimiter() {
		return delimiter;
	}

	/**
	 * Returns the fieldSpecs.
	 * @return FieldSpec[]
	 */
	public FieldSpec[] getFieldSpecs() {
		return fieldSpecs;
	}

	/**
	 * Returns the handlerSpecs.
	 * @return SectionHandlerSpec[]
	 */
	public SectionHandlerSpec[] getHandlerSpecs() {
		return handlerSpecs;
	}

	/**
	 * Returns the rowcount.
	 * @return int
	 */
	public int getRowcount() {
		return rowcount;
	}

	/**
	 * Returns the type.
	 * @return int
	 */
	public int getType() {
		return type;
	}

	/**
	 * Sets the delimiter.
	 * @param delimiter The delimiter to set
	 */
	public void setDelimiter(String delimiter) {
		this.delimiter = delimiter;
	}

	/**
	 * Sets the fieldSpecs.
	 * @param fieldSpecs The fieldSpecs to set
	 */
	public void setFieldSpecs(FieldSpec[] fieldSpecs) {
		this.fieldSpecs = fieldSpecs;
	}

	/**
	 * Sets the handlerSpecs.
	 * @param handlerSpecs The handlerSpecs to set
	 */
	public void setHandlerSpecs(SectionHandlerSpec[] handlerSpecs) {
		this.handlerSpecs = handlerSpecs;
	}

	/**
	 * Sets the rowcount.
	 * @param rowcount The rowcount to set
	 */
	public void setRowcount(int rowcount) {
		this.rowcount = rowcount;
	}

	/**
	 * Sets the type.
	 * @param type The type to set
	 */
	public void setType(int type) {
		this.type = type;
	}

}
