package com.gonetix.framework.textengine;

import java.io.*;

/**
 * @author SLiu
 *
 */
public class TextDataFileReaderFactory {

	static TextDataFileReaderFactory factory = null;
	/**
	 * Constructor for TextDataFileReaderFactory.
	 */
	public TextDataFileReaderFactory() {
		super();
	}
	
	
	public synchronized TextDataFileReaderFactory getTextDataFileReaderFactory()
	{
		if (factory==null)	factory = new TextDataFileReaderFactory();		
		return factory;		
	}
	
	public TextDataFileReader getTextDataFileReader(String systemId, FileSpec spec) throws IOException
	{
		return getTextDataFileReader(new File(systemId), spec);
	}
	
	public TextDataFileReader getTextDataFileReader(File file, FileSpec spec) throws IOException
	{
		return getTextDataFileReader(new FileReader(file), spec);
	}
	
	public TextDataFileReader getTextDataFileReader(Reader xreader, FileSpec spec) throws IOException
	{
		TextDataFileReader reader = null;		
		switch(spec.getFileType())
		{
			case FileSpec.FILE_TYPE_DELIMITED:
			case FileSpec.FILE_TYPE_DELIMITED_QUOTED:
			case FileSpec.FILE_TYPE_FIXED_LENGTH:
			reader = new PlainTextDataFileReader(xreader, spec);
			break;
			case FileSpec.FILE_TYPE_XLS:
			//will implement latter
			break;
			case FileSpec.FILE_TYPE_XML:
			//will implement latter
			break;
			default:
			throw new RuntimeException("Unsurported file format exception.");			
			
		}		
		return reader;
		
	}

}
