package com.gonetix.framework.textengine;

import java.util.ArrayList;

/**
 * @author Sunny Liu
 *
 */
public final class TextUtil {

	public static final char DOUBLE_QUOTE = '"';
	public static final char APOS_QUOTE = '\'';
	
	private char stringQuote = DOUBLE_QUOTE;
	private ArrayList splitHolder = null;
	
	/**
	 * Constructor for TextUtil.
	 */
	public TextUtil() 
	{
		super();
		 splitHolder = new ArrayList(100);
	}
	
	
	public String[] split(String text, char delimiter)
	{
		String[] ret = null;
		if (text==null) return ret;
		int length = text.length();
		StringBuffer buffer = new StringBuffer(100);		
		boolean isInQuote = false;
				
		for (int i=0; i<length; i++){
			char c = text.charAt(i);
			if(c==stringQuote && isInQuote==false){
				isInQuote=true;				
			}else if (c==stringQuote && isInQuote==true){								
				isInQuote= false;
			}else if (c==delimiter && isInQuote==false){
				splitHolder.add(buffer.toString());
				buffer.setLength(0);
			}else{
				buffer.append(c);
			}			
		}
		
		if (buffer.length()>0)
		{
			splitHolder.add(buffer.toString());
			buffer.setLength(0);
		}		
		ret = new String[splitHolder.size()];
		splitHolder.toArray(ret);
		splitHolder.clear();		
		return ret;
	}
	
	
	public String[] split(String text, FieldSpec[] fieldSpecs)
	{
		String[] ret = null;
		if (text==null) return ret;		
		char[] textCharArray = text.toCharArray();		
		int length = fieldSpecs.length;
		ret = new String[length];
		for (int i=0; i<length; i++){
			FieldSpec currField = fieldSpecs[i];
			ret[i] = new String(textCharArray, currField.getStartAt(), currField.getLength());
		}	
		return ret;
	}
	

	/**
	 * Returns the stringQuote.
	 * @return char
	 */
	public char getStringQuote() {
		return stringQuote;
	}

	/**
	 * Sets the stringQuote.
	 * @param stringQuote The stringQuote to set
	 */
	public void setStringQuote(char stringQuote) {
		this.stringQuote = stringQuote;
	}

}
