/*
 * SQLStatement.java
 *
 * Created on August 12, 2002, 11:28 AM
 */

package com.gonetix.framework.xmlEngine;

/**
 *
 * @author  SLiu
 */
public final class SQLStatement {
    public static final int CALLABLE_STATEMENT = 3;
    public static final int PREPARED_STATEMENT = 2;
    public static final int REGULAR_STATEMENT = 1;
    public static final int UNKNOW_STATEMENT = 0;
    private static final String CALLABLE = "CALLABLE";
    private static final String PREPARED = "PREPARED";
    private static final String REGULAR = "REGULAR";
      
    private int statementType;
    private String statement;
    private String id = "DEFAULT";
    
    /** Creates a new instance of SQLStatement */
    public SQLStatement(String id, String type, String statement) {
        if ( id!=null) this.id = id;
        initStatementType(type);
        this.statement = statement;
    }
    
    public String getId(){
            return this.id;
    }
    
    public String getSatement()
    {
        return this.statement;
    }
    
    public int getStatementType()
    {
        return this.statementType;
    }
    
    
    protected void initStatementType(String typeString)
    {        
        if (typeString==null) {
            statementType = PREPARED_STATEMENT;
        }else if (typeString.equalsIgnoreCase(REGULAR)){
            statementType = REGULAR_STATEMENT;
        }else if (typeString.equalsIgnoreCase(CALLABLE)){
            statementType = CALLABLE_STATEMENT;
        }else if (typeString.equalsIgnoreCase(PREPARED)){
            statementType = PREPARED_STATEMENT;
        }else{
            statementType = UNKNOW_STATEMENT;
        }        
    }
    
}
