/*
 * StatementReader.java
 *
 * Created on August 12, 2002, 1:54 PM
 */

package com.gonetix.framework.xmlEngine;

import com.gonetix.framework.util.*;

import java.io.*;
import java.util.*;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;

/**
 *
 * @author  SLiu
 */
public class StatementReader  extends DefaultHandler {
    
    private String targetID = null;   
    private SQLStatement stmt = null;
    
    public StatementReader() {  }   
    
    
    public SQLStatement getSQLStatement(String id, String xmlFilePath)
    {
        targetID = id;
        try{
            FileInputStream fin = new FileInputStream(xmlFilePath);
            parse(fin);
        }catch(Exception e){
            e.printStackTrace();
        }
        
        return stmt;
    }    
    
    private void parse(InputStream in)
    {
        XMLReader xmlReader = null;      
        try{            
            SAXParserFactory spfactory = SAXParserFactory.newInstance();
            spfactory.setValidating(false);        
            SAXParser saxParser = spfactory.newSAXParser();
            xmlReader = saxParser.getXMLReader();            
            xmlReader.setContentHandler(this);
            xmlReader.setEntityResolver(this);
            xmlReader.setErrorHandler(this);            
            InputSource source = new InputSource(in);
            xmlReader.parse(source);            
        }catch(Exception ex){
            ex.printStackTrace();
        }
        
    }
    
    boolean started = false;    
    String id = null;
    String type = null;
    StringBuffer value = new StringBuffer(100);
    
    public void startElement(String namespaceURI, String localName, String qName, Attributes atts)
    throws SAXException 
    {
       value.setLength(0);
       id = atts.getValue("id");
       type = atts.getValue("type");
       if (id==null || id.length()==0) throw new SAXException("FATAL: id attribute is required.");
       if (qName.equals("sql") && id!=null && id.equals(targetID)){                        
            if (type==null || type.length()==0) type = "REGULAR";
            started = true;
       }
    }
    
    public void characters(char[] ch, int start, int length)
    throws SAXException 
    {       
        String content = (new String(ch, start, length)); 
        if(content!=null && length>0){            
         content=StringUtil.decodeEntity(content, "&#60;|&lt;", "<");         
         content=StringUtil.decodeEntity(content, "&#62;|&lt;", "<");        
         content=StringUtil.decodeEntity(content, "&#47;", "/");
         content=StringUtil.decodeEntity(content, "&#38;|&amp;", "&");
        }
        if( started) value.append(content);
    }
    
    public void endElement(String namespaceURI, String localName, String qName)
    throws SAXException 
    {
        if ( qName.equals("sql") &&  started ){
            String pvalue = value.toString();            
            pvalue = StringUtil.strip(pvalue);
            try{
                stmt = new SQLStatement(id, type, pvalue);                
            }catch(Exception e){
                throw new SAXException("FATAL: " + e.toString());
            }            
            value.setLength(0);
            started = false;                     
        }
        id = null ; type = null;
    }
    
    
    
}
