/*
 * WriterTask.java
 *
 * Created on August 12, 2002, 12:09 PM
 */

package com.gonetix.framework.xmlEngine;

import java.util.*;
/**
 *
 * @author  SLiu
 */
public final class WriterTask {
    
    private Properties cfgProp; 
    private ArrayList params;
    
    /** Creates a new instance of WriterTask */
    public WriterTask() {
        cfgProp = new Properties();
        params = new ArrayList();
    }
    
    public void setCfg(String key, String value){
        cfgProp.setProperty(key, value);
    }
    
    public String getCfg(String key){
        return cfgProp.getProperty(key);
    }
    
    public void addParam(Parameter param){
        params.add(param);
    }
    
    public Object[] getParams()
    {     
        ArrayList al = new ArrayList();
        Iterator iter = params.iterator();
        while ( iter.hasNext()){
            Parameter param = (Parameter)iter.next();
            al.add(param.getObject());            
        }
        return al.toArray();
    }
    
    public int[] getParamTypes()
    {     
        int[] types = new int[params.size()];
        int pos = 0;
        Iterator iter = params.iterator();
        while ( iter.hasNext()){
            Parameter param = (Parameter)iter.next();
            types[pos++] =  param.getType();           
        }
        return types;
    }
    
}
