/*
 * XMLProcessor.java
 *
 * Created on August 9, 2002, 10:38 AM
 */

package com.gonetix.framework.xmlEngine;


import java.io.*;
import java.util.*;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;

/**
 *
 * @author  SLiu
 */
public class XMLProcessor extends AbstractHandler{
    
    protected InputStream in = null;
    protected String targetName = null;    
    /** Creates a new instance of XMLProcessor */
    public XMLProcessor(InputStream in) {
        super();
        this.in = in;
    }
    
    public Properties findNode(String nodeName)
    throws Throwable
    {
        this.targetName = nodeName;
        Properties node = new Properties();        
        if ( targetName!=null)
        try{
            /* use trax API to get a XML reader*/
            SAXParserFactory spfactory = SAXParserFactory.newInstance();
            spfactory.setValidating(true);         
            SAXParser saxParser = spfactory.newSAXParser();
            xmlReader = saxParser.getXMLReader();            
            xmlReader.setContentHandler(this);
            xmlReader.setErrorHandler(this);            
            InputSource source = new InputSource(this.in);
            xmlReader.parse(source);            
        }catch(Exception ex){
            ex.printStackTrace();
            throw new Exception(ex.getMessage());
        }
        return node;
    }
    
    boolean found = false;    
    
    public void startElement(String namespaceURI, String localName, String qName, Attributes atts)
    throws SAXException 
    {
       if (qName.equals(targetName)){
           found = true;
           xmlReader.setContentHandler(new GenericHandler(this));
       }
    }
    public void endElement(String namespaceURI, String localName, String qName)
    throws SAXException 
    {
        
    }

    
    
}
