/*
 * XLSRender.java
 *
 * Created on August 13, 2002, 11:01 AM
 */

package com.gonetix.framework.xsltEngine;


import com.gonetix.framework.dbpublish.*;
import java.io.*;
import java.sql.*;
/**
 *
 * @author  SLiu
 */
public class XLSRender {
    
   private String excelHeader = null;
   private String excelFooter = null;
   private FileWriter excelOut = null;
   private XSLTTransformer xlstTransformer = null;
   private int maxRowToRender = 30;
   
   /** Creates a new instance of XLSRender */
    public XLSRender(String sysid) throws Exception
    {
        xlstTransformer = new XSLTTransformer();
        excelOut = new FileWriter(sysid);
        writeHeader();
        xlstTransformer.setOutput(excelOut);
    }
    
    public void setStyleSheet(Reader reader) throws Exception
    {
        xlstTransformer.init(reader);
    }
    
    public void setStyleSheet(String xslfile) throws Exception
    {
        xlstTransformer.init(xslfile);
    }
    
    private void writeHeader() throws IOException
    {
	    excelOut.write("<html xmlns:v=\"urn:schemas-microsoft-com:vml\" ");
	    excelOut.write("xmlns:o=\"urn:schemas-microsoft-com:office:office\" ");
	    excelOut.write("xmlns:x=\"urn:schemas-microsoft-com:office:excel\" ");
	    excelOut.write("xmlns=\"http://www.w3.org/TR/REC-html40\">");
	    excelOut.write("<head>");
	    excelOut.write("<meta http-equiv='Content-Type' content=\"application/vnd.ms-excel; charset=windows-1252\">");
	    excelOut.write("<meta name=ProgId content=Excel.Sheet>");
	    excelOut.write("<meta name=Generator content=\"Microsoft Excel 5\">");
	    excelOut.write("<!--[if !mso]>");
	    excelOut.write("<style>");
	    excelOut.write("v\\:* {behavior:url(#default#VML);}");
	    excelOut.write(" o\\:* {behavior:url(#default#VML);}");
	    excelOut.write(" x\\:* {behavior:url(#default#VML);}");
	    excelOut.write(" .shape {behavior:url(#default#VML);}");
	    excelOut.write("</style>");
	    excelOut.write("<![endif]--><!--[if gte mso 9]><xml>");
	    excelOut.write("<o:DocumentProperties><o:Author>Sunny Liu</o:Author><o:LastAuthor>Sunny Liu</o:LastAuthor>");
	    excelOut.write("<o:Created>2001-2-10T05:32:42Z</o:Created><o:LastSaved>2001-2-10T05:44:13Z</o:LastSaved>");
	    excelOut.write("<o:Company>Gonetix</o:Company><o:Version>9.3821</o:Version>");
	    excelOut.write("</o:DocumentProperties><o:OfficeDocumentSettings><o:DownloadComponents/>");
	    excelOut.write("<o:LocationOfComponents HRef=\"file:\\\\products\\Public\\Products\\Applications\\User\\Office_2000_SR1\\Premium\\Internal\\CD1\\msowc.cab\"/> ");
	    excelOut.write("</o:OfficeDocumentSettings></xml><![endif]-->");
	    excelOut.write("<style><!--table {mso-displayed-decimal-separator:\"\\.\"; mso-displayed-thousand-separator:\"\\,\";} ");
	    excelOut.write("@page  {margin:1.0in .75in 1.0in .75in; mso-header-margin:.5in; mso-footer-margin:.5in;}");
	    excelOut.write(" tr  {mso-height-source:auto;}");
	    excelOut.write(" col {mso-width-source:auto;}");
	    excelOut.write(" br  {mso-data-placement:same-cell;}");
	    excelOut.write(" .style0 {mso-number-format:General; ");
	    excelOut.write("  text-align:general; vertical-align:bottom; white-space:nowrap; mso-rotate:0; ");
	    excelOut.write(" mso-background-source:auto; mso-pattern:auto; color:windowtext; font-size:10.0pt;");
	    excelOut.write(" font-weight:400; font-style:normal; text-decoration:none; font-family:Arial; ");
	    excelOut.write(" mso-generic-font-family:auto; mso-font-charset:0; border:none; ");
	    excelOut.write(" mso-protection:locked visible; mso-style-name:Normal; mso-style-id:0;}");
	    excelOut.write(" .style20  {mso-number-format:0%;  mso-style-name:Percent; mso-style-id:5;} ");
	    excelOut.write(" td {mso-style-parent:style0; padding:0px; mso-ignore:padding;");
	    excelOut.write(" color:windowtext; font-size:10.0pt; font-weight:400; font-style:normal; ");
	    excelOut.write(" text-decoration:none;   font-family:Arial;  mso-generic-font-family:auto; mso-font-charset:0;");
	    excelOut.write(" mso-number-format:General; text-align:general; vertical-align:bottom; border:none;");
	    excelOut.write(" mso-background-source:auto; mso-pattern:auto; mso-protection:locked visible; white-space:nowrap; mso-rotate:0;} ");
	    excelOut.write(" .xl24 {mso-style-parent:style0; font-size:12.0pt;  font-weight:700; ");
	    excelOut.write(" font-family:Arial, sans-serif; mso-font-charset:0; text-align:center;}");
	    excelOut.write(" .xl25 {mso-style-parent:style20; mso-number-format:0%;} --> </style> ");
	    excelOut.write("<!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets>");
	    excelOut.write("<x:ExcelWorksheet><x:Name>Sheet1</x:Name><x:WorksheetOptions><x:Print><x:ValidPrinterInfo/>");
	    excelOut.write("<x:HorizontalResolution>600</x:HorizontalResolution><x:VerticalResolution>600</x:VerticalResolution>");
	    excelOut.write("</x:Print><x:Selected/><x:Panes><x:Pane><x:Number>3</x:Number>");
	    excelOut.write("<x:ActiveRow>4</x:ActiveRow><x:ActiveCol>4</x:ActiveCol></x:Pane></x:Panes>");
	    excelOut.write("<x:ProtectContents>False</x:ProtectContents><x:ProtectObjects>False</x:ProtectObjects>");
	    excelOut.write("<x:ProtectScenarios>False</x:ProtectScenarios></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets>");
	    excelOut.write("<x:WindowHeight>6285</x:WindowHeight><x:WindowWidth>10380</x:WindowWidth><x:WindowTopX>480</x:WindowTopX>");
	    excelOut.write("<x:WindowTopY>15</x:WindowTopY><x:ProtectStructure>False</x:ProtectStructure><x:ProtectWindows>False</x:ProtectWindows>");
	    excelOut.write("</x:ExcelWorkbook></xml><![endif]--><!--[if gte mso 9]><xml>");
	    excelOut.write("<o:shapedefaults v:ext=\"edit\" spidmax=\"1026\"/></xml><![endif]--><!--[if gte mso 9]><xml>");
	    excelOut.write("<o:shapelayout v:ext=\"edit\"><o:idmap v:ext=\"edit\" data=\"1\"/></o:shapelayout></xml><![endif]--></head> ");
	    excelOut.write("<body link=blue vlink=purple>");
	    excelOut.write("<table x:str border=0 cellpadding=0 cellspacing=0 width=734 style='border-collapse: collapse;table-layout:fixed;width:551pt'>");
	    excelOut.write("<col width=94 style='mso-width-source:userset;mso-width-alt:3437;width:71pt'>");
	    excelOut.write("<col width=64 span=10 style='width:48pt'>");	    
	    excelOut.flush();
	}
    
    
    
    public void render(Reader reader) throws Exception
    {
        xlstTransformer.transform(reader);
    }
    
    public void render(ResultSet rs) throws Exception
    {
        XMLBuilder xmlBuilder = new XMLBuilder();        
        ResultSetMetaData rsmd = rs.getMetaData();
        int colcount = rsmd.getColumnCount();
        int[] colType = xmlBuilder.getColumnTypes(rsmd);            
        String[] colnames = xmlBuilder.getColumnNames(rsmd); 
        
        int rowCount = 0;
        
        StringWriter pw = null;
        StringReader sr = null;
        while ( rs.next() ){
            if ( (rowCount % maxRowToRender) == 0 ){               
                pw = new java.io.StringWriter();
                pw.write("<datas>");
            }            
            xmlBuilder.biuldXmlRow(pw, colcount,colnames,colType,"row",rs);
            rowCount ++; 
            if ( (rowCount % maxRowToRender) == 0 ){
                    pw.write("</datas>");
                    sr = new StringReader(pw.toString());
                    xlstTransformer.transform(sr);
            }
        }
        if ( (rowCount % maxRowToRender) != 0 ){
             pw.write("</datas>");
             sr = new StringReader(pw.toString());
             xlstTransformer.transform(sr);
        }        
    }
    
    
    public void setMaxRowToRender(int value)
    {
        this.maxRowToRender = value;
    }
    
    public int getMaxRowToRender(){
        return this.maxRowToRender;
    }
    
    public void close()  throws IOException
    {
        writeFooter();
        excelOut.flush();
        excelOut.close();
    }
    
    private void writeFooter() throws IOException
    {
        excelOut.write("<tr height=17 style='height:12.75pt'>");
	excelOut.write("<td height=17 colspan=11 style='height:12.75pt;mso-ignore:colspan'></td></tr>");
	excelOut.write("<![if supportMisalignedColumns]><tr height=0 style='display:none'><td width=94 style='width:71pt'></td>");
	excelOut.write("<td width=64 style='width:48pt'></td><td width=64 style='width:48pt'></td><td width=64 style='width:48pt'></td>");
	excelOut.write("<td width=64 style='width:48pt'></td><td width=64 style='width:48pt'></td><td width=64 style='width:48pt'></td>");
	excelOut.write("<td width=64 style='width:48pt'></td><td width=64 style='width:48pt'></td><td width=64 style='width:48pt'></td>");
	excelOut.write("<td width=64 style='width:48pt'></td></tr><![endif]>");
	excelOut.write("</table></body></html>");
	excelOut.flush();    	  
    }
    
}
