/*
 * TaskHandler.java
 *
 * Created on August 13, 2002, 4:53 PM
 */

package com.gonetix.jextract;


import java.io.*;
import java.util.*;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.FactoryConfigurationError;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

import com.gonetix.framework.xmlEngine.*;
import com.gonetix.framework.dbpublish.*;
import com.gonetix.framework.util.*;
import com.gonetix.framework.xsltEngine.*;

/**
 *
 * @author  SLiu
 */
public class TaskHandler extends DefaultHandler {
    
    protected XMLProcessor parent;
    protected String tag;
    protected Task task;
    /** Creates a new instance of TaskHandler */
    public TaskHandler(XMLProcessor parent, Task task) {
        this.parent = parent;
        this.task = task;
    }
    
    public void init(String qname, Attributes atts)
    {
        this.tag = qname;
        int num = atts.getLength(); 
        for(int i=0; i<num; i++){
            task.setProperty(atts.getQName(i), atts.getValue(i));
         }
    }
    
    boolean started = false;    
    String key = null;
    StringBuffer value = new StringBuffer(100);
    String stmtType = null;
    String stmtId=null;
    
    public void startElement(String namespaceURI, String localName, String qName, Attributes atts)
    throws SAXException 
    {
        value.setLength(0);
        if(qName.equals("statement")){
            stmtType = atts.getValue("type");
            stmtId = atts.getValue("id"); 
            started = true;
        }else if (qName.equals("param")){
            started = true;
            String type = atts.getValue("type");
            String foramt = atts.getValue("format");
            String paramValue = atts.getValue("value");
            String cmdIndex = atts.getValue("cmdIndex");            
            try{
                Parameter param;
                if (paramValue!=null && paramValue.equals("CMDLINE")){                    
                    param = new Parameter(type, paramValue, foramt);                     
                    param.setCmdIndex(cmdIndex);                    
                }else{
                    param = new Parameter(type, paramValue, foramt);
                }
                task.addParam(param);               
            }catch(Exception e){
                throw new SAXException("FATAL: " + e.toString());
            }  
        }else{            
            key = qName;
            started = true;
        }
    }
    
    public void characters(char[] ch, int start, int length)
    throws SAXException 
    {       
        String content = (new String(ch, start, length)); 
        if(content!=null && length>0){            
         content=StringUtil.decodeEntity(content, "&#60;|&lt;", "<");         
         content=StringUtil.decodeEntity(content, "&#62;|&lt;", "<");        
         content=StringUtil.decodeEntity(content, "&#47;", "/");
        }
        if( started) value.append(content);
    }
    
    public void endElement(String namespaceURI, String localName, String qName)
    throws SAXException 
    {
        String pvalue = value.toString();
        value.setLength(0);
        pvalue = StringUtil.strip(pvalue);
        if ( qName.equals(tag)){            
            parent.setHandler(parent);            
        }else if (qName.equals("statement")){
            try{
               task.setSQLStatement(new SQLStatement(stmtId, stmtType, pvalue));
            }catch(Exception e){
               throw new SAXException("FATAL: " + e.toString());
            }
            stmtType = null;
            stmtId=null;
        }else if (qName.equals("param")){
            ;
        }else{            
            if(pvalue.length()>0) {                
                task.setProperty(key, pvalue);   
            }
        }            
        key = null ;        
        started = false;
    }     
}
