/*
 * Util.java
 *
 * Created on September 5, 2002, 2:20 PM
 */

package com.gonetix.jextract;

import java.util.*;
/**
 *
 * @author  SLiu
 */
public final class Util {
    
    private final static char VARBEGIN = '{';
    private final static char VAREND = '}';
    private final static String VARIABLE = "VARIABLE";
    
    /** Creates a new instance of Util */
    public Util() {
    }
    
    
    public static Variable[] parserPattern(String source, Vector vector)
    {
        if ( source == null ) return null;
        Vector v = new Vector(20);
        boolean isVarStart = false;
        Variable var = null;
        int length = source.length();
        StringBuffer buffer = new StringBuffer(20);
        for(int i=0; i<length; i++){
            char c = source.charAt(i);
            if ( c==VARBEGIN && isVarStart == false){
                vector.addElement(buffer.toString());
                buffer.setLength(0);
                var = new Variable(i);
                var.setArrayIndex(vector.size());
                isVarStart = true;                
            }else if (isVarStart == true && c==VAREND){
                isVarStart = false;
                var.setEndIndex(i);
                var.setVarName(buffer.toString());
                v.addElement(var);
                vector.addElement(VARIABLE);
                var = null;
                buffer.setLength(0);
            }else if (isVarStart == true && c!=VAREND){
                buffer.append(c);
            }else if (isVarStart == false){
                buffer.append(c);                
            }
        }        
        if ( buffer.length() > 0 ) vector.addElement(buffer.toString());
        Variable[] ret =new Variable[ v.size()];
        v.copyInto(ret);
        return ret;
    }
    
    
    public static boolean isPositiveInteger(String source)
    {
        if ( source==null || source.length()==0 || 
        source.indexOf(".")!=-1 || source.indexOf("-")!=-1) 
                                return false;
        try{
            return (Integer.valueOf(source).intValue()>-1);
        }catch(Exception ex){
            return false;
        }        
    }
    
    
    public static void main(String[] args)
    {
        String pattern = "{DATE}   HERE YOUR GO {0}, {1}, {3} my life {ROWCOUNT} is much better now.";
        //String pattern = "    HERE YOUR GO {0}, {1}, {3} my life {ROWCOUNT} is much better now.";
        Object[] params = new Object[]{new java.util.Date(), "23435", "third", "forth", "fifth"} ;      
        System.out.println(StringFormater.format(pattern, params));
    }
    
}
