/*
 * Task.java
 *
 * Created on August 13, 2002, 4:15 PM
 */

package com.gonetix.report;

import com.gonetix.framework.dbengine.*;
import com.gonetix.framework.dbpublish.*;
import com.gonetix.framework.util.*;


import java.io.*;
import java.util.*;

/**
 *
 * @author  SLiu
 */
public class ReportTask {
    
    private Properties taskProps;    
    private ArrayList paramList;
    private SQLStatement sqlStmt;
    
    public ReportTask() {
        taskProps = new Properties();
        paramList = new ArrayList();
    }
    
    
    public void initProperties(Properties prop)
    {
    	taskProps.putAll(prop);
    }
    
    public void setSQLStatement(SQLStatement sqlStmt)
    {
        this.sqlStmt = sqlStmt;
    }  
    
    public Properties getProperties()
    {
        return this.taskProps;
    }
    
    public String getProperty(String key, String dfValue)
    {
        return taskProps.getProperty(key, dfValue);
    }
    
    public String getProperty(String key)
    {
        return taskProps.getProperty(key);
    }
    
    public void setProperty(String key, String value)
    { 
        this.taskProps.setProperty(key, value);
    } 
    
    public void addAll(Properties props)
    {
        this.taskProps.putAll(props);
    }
    
    public String getStatement()
    {
        if (this.sqlStmt!=null){
            return this.sqlStmt.getSqlText();
        }else{
            return null;
        }
    }
    public String getStatementId()
    {
        if (this.sqlStmt!=null){
            return this.sqlStmt.getId();
        }else{
            return null;
        }
    }
    
    public int getStatementType()
    {
        if (this.sqlStmt!=null){
            return this.sqlStmt.getType();
        }else{
            return SQLStatement.UNKNOWN;
        }
    }
    
    public void addParam(SQLParameter param)
    {
         paramList.add(param);  
    }
    
    public void addAllParam(Collection params)
    {
         paramList.addAll(params);
    }
    
    public SQLParameter[] getParams()
    {
        SQLParameter[] ps = new SQLParameter[paramList.size()];
        paramList.toArray(ps);        
        return ps;
    }
    
}
