package com.gonetix.swing.SQLUI;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.text.*;


public final class SQLConnForm extends JPanel {
  
  private String[] labels = { "JDBC Driver:", "JDBC URL:", "JDBC User:", "JDBC Password:" };
  private String[] descs = {"JDBC Driver", "JDBC URL", "JDBC User", "JDBC Password"};
  private String[] dvrList = {"com.sybase.jdbc2.jdbc.SybDriver", 
  			      "oracle.jdbc.driver.OracleDriver", 
  			      "com.mysql.jdbc.Driver", 
  			      "com.microsoft.jdbc.sqlserver.SQLServerDriver", 
  			      "COM.ibm.db2.jdbc.net.DB2Driver", 
  			      "com.pervasive.jdbc.v2.Driver"};
  			      
  private String[] urlList = {"jdbc:sybase:Tds:localhost:2638", 
  			      "jdbc:oracle:thin:@davew:1521:testdb", 
  			      "jdbc:mysql://[hostname][:port]/[dbname]", 
  			      "jdbc:microsoft:sqlserver://[hostname]:1433", 
  			      "jdbc:db2://[host]:[port]/[database]", 
  			      "jdbc:pervasive://[host]:[port]/[database]"};
  
  private JPanel formPanel = null;
  private JPanel btnPanel = null;
  
  private JComboBox jcbDvr = null;
  private JComboBox jtfUrl = null;
  private JPasswordField jpfPwd = null;
  private JTextField jtfUser = null;
  private JButton jbtConn = null;
  private JButton jbtClose = null;
  
  private IConnectable parent = null;
  
  public SQLConnForm(IConnectable parent) {
	this.parent = parent;
	init();
  } 
  
  private void init() {    
    this.setLayout(new BorderLayout());
    formPanel = new JPanel();    
    formPanel.setLayout(new GridBagLayout());
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.anchor = GridBagConstraints.WEST;
    gbc.insets = new Insets(2, 2, 2, 2);    
    
    JLabel l = new JLabel(labels[0]);
    jcbDvr = new JComboBox(dvrList);
    jcbDvr.setEditable(true);
    jcbDvr.setToolTipText(descs[0]);
    l.setLabelFor(jcbDvr); 
    gbc.gridy = 0;
    gbc.gridx = 0;
    formPanel.add(l, gbc);
    gbc.gridx = 1;
    formPanel.add(jcbDvr, gbc);
    
    l = new JLabel(labels[1]);
    jtfUrl = new JComboBox(urlList);
    jtfUrl.setEditable(true);
    jtfUrl.setToolTipText(descs[1]);
    l.setLabelFor(jcbDvr); 
    gbc.gridy = 1;
    gbc.gridx = 0;
    formPanel.add(l, gbc);
    gbc.gridx = 1;
    formPanel.add(jtfUrl, gbc);
    
    l = new JLabel(labels[2]);
    jtfUser = new JTextField(25);
    jtfUser.setToolTipText(descs[2]);
    l.setLabelFor(jcbDvr); 
    gbc.gridy = 2;
    gbc.gridx = 0;
    formPanel.add(l, gbc);
    gbc.gridx = 1;
    formPanel.add(jtfUser, gbc);
    
    l = new JLabel(labels[3]);
    jpfPwd = new JPasswordField(25);
    jpfPwd.setToolTipText(descs[3]);
    l.setLabelFor(jcbDvr); 
    gbc.gridy = 3;
    gbc.gridx = 0;
    formPanel.add(l, gbc);
    gbc.gridx = 1;
    formPanel.add(jpfPwd, gbc);
    this.add(formPanel, BorderLayout.CENTER);
    
    btnPanel = new JPanel();
    btnPanel.setLayout(new GridLayout(1,2));
    jbtConn = new JButton("Connect");  
    jbtConn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent ev) {
        	java.util.Properties prop = new java.util.Properties();
        	prop.setProperty("driver", (String)jcbDvr.getSelectedItem());
        	prop.setProperty("url", (String)jtfUrl.getSelectedItem());
        	prop.setProperty("user", jtfUser.getText());
        	prop.setProperty("password", String.valueOf(jpfPwd.getPassword()));        	
        	try{
        		SQLConnForm.this.parent.connect(prop);
        	}catch(Exception ex){
        
        	}
     	}
     });
    btnPanel.add(jbtConn);
    jbtClose = new JButton("Close"); 
    jbtClose.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent ev) {
        	try{
        	     SQLConnForm.this.parent.close();
        	}catch(Exception ex){
        
        	}
     	}
     });
    btnPanel.add(jbtClose);
    this.add(btnPanel, BorderLayout.SOUTH);
  }
  
  
  
  public static void main(String[] args) { 

    TestConnection tc = new TestConnection();
    final SQLConnForm form = new SQLConnForm(tc);
    JFrame f = new JFrame();
    f.addWindowListener(new BasicWindowMonitor());
    Container c = f.getContentPane();
    c.setLayout(new BorderLayout());
    c.add(form, BorderLayout.CENTER);    
    f.pack();
    f.setVisible(true);
  }

  
 
  
}
