package com.gonetix.swing.sql.base;

import java.util.*;
import java.sql.*;
import java.io.Serializable;

public final class ConnInfo extends Properties implements Serializable
{  
  String name;  
  String[] catalogs;
  
  public ConnInfo(String name)
  {
      super();
      this.name = name;
  }

  public String[] getCatalogs()
  {
      return this.catalogs;
  }

  public void setCatalogs(String[] catalogs)
  {
        this.catalogs = catalogs;
  }

  public String getUser()
  {
    return super.getProperty("user");
  }

  public void setUser(String newUser)
  {
    super.setProperty("user", newUser);    
  }

  public String getName()
  {
    return name;
  }

  public void setName(String newName)
  {
    name = newName;
  }

  public String getPassword()
  {
    return super.getProperty("password");
  }

  public void setPassword(String newPassword)
  {
    super.setProperty("password", newPassword);
  }

  public String getDriver()
  {
    return super.getProperty("driver");
  }

  public void setDriver(String newDriver)
  {
    super.setProperty("driver", newDriver);    
  }

  public String getUrl()
  {
    return super.getProperty("url");
  }

  public void setUrl(String newUrl)
  {
    super.setProperty("url", newUrl);
  }

  public Object[][] getInfoes()
  {
      int size = size();
      Object[][] objs = new Object[size][2];      
      Enumeration enum =  keys();
      int y=0;
      while(enum.hasMoreElements()){
          String key = (String)enum.nextElement();
          objs[y][0] = key;
          objs[y++][1] = super.getProperty(key);
      }
      return objs;
  }

  public String toString()
  {
    return this.name;
  }

  
}