package com.gonetix.swing.sql.base;

import java.sql.*;
import java.util.*;


public final class DBConnectionFactory 
{ 
  public static Connection createConnection(ConnInfo connInfo) throws SQLException
  {
      Connection conn = null;
      try{
          Class.forName(connInfo.getDriver()).newInstance(); 
          conn = DriverManager.getConnection(connInfo.getUrl(), connInfo.getUser(), connInfo.getPassword());
      }catch(Exception ex){
          throw new SQLException("Failed to create database conntion.\nReason: " + ex.toString());
      }
      return conn;
  }

  public static boolean testConnection(ConnInfo connInfo) throws SQLException
  {
      boolean isOk = false;
      try{
          Class.forName(connInfo.getDriver()).newInstance(); 
          Connection conn = DriverManager.getConnection(connInfo.getUrl(), connInfo.getUser(), connInfo.getPassword());
          conn.close();
          isOk = true;
      }catch(Exception ex){
          throw new SQLException("Failed to create database conntion.\nReason: " + ex.toString());
      }
      return true;
  }
}