package com.gonetix.swing.sql.base;


import java.sql.*;
import java.util.*;
import java.io.*;
import com.gonetix.swing.sql.swing.*;
import com.gonetix.swing.EditorComponents.SQLUI.*;


public final class SQLHandler 
{
  private ConnNode connNode;  
  private static SQLHandler handler = null;
  private final static char SPACE = ' ';
  private final static char DASH = '-';
  private final static String SPACESTR = " ";
  private final static String NEWLINE = "\n";
  private SQLConsolePane console = null;
  private SQLEditorPane sqlEditor = null;
  private QueryResultRender resultRender = null;
  
  protected SQLHandler()
  {     
  }
  
  public void setQueryResultRender(QueryResultRender resultRender)
  {
      this.resultRender = resultRender;
  }
  
  public static SQLHandler getInstance()
  {
        if (handler==null) handler = new SQLHandler();
        return handler;
  }

  public void setConsole(SQLConsolePane console)
  {
      this.console = console;
  }

  public void setConnNode(ConnNode connNode)
  {
        this.connNode = connNode;
  }
  
  public void setSQLSource(SQLEditorPane sqlEditor)
  {
      this.sqlEditor = sqlEditor;
  }
  
  
  public void handleSQLExecutionEvent()
  {
      
  }
  
  

  public static TableViewInfo getTableViewInfo(Connection connection, String tablename) throws SQLException
  {
        TableViewInfo tbInfo = null;
        Statement stmt = connection.createStatement();
        ResultSet rs = stmt.executeQuery(TableViewInfo.getQueryString(tablename));
        if (rs!=null ){
                ResultSetMetaData rsmd = rs.getMetaData();
                tbInfo = new TableViewInfo(tablename, rsmd);
        }
        return tbInfo;
  }
  
}