package com.gonetix.swing.sql.base;

import java.util.*;
import java.util.regex.*;

public class SQLTextParser 
{
  private static SQLTextParser sQLTextParser = null;
  private static final char SPACE = ' ';
  private static final char G = 'G';
  private static final char g = 'g';
  private static final char O = 'O';
  private static final char o = 'o';
  private static final char QUESTIONMARK = '?';
  
  private static final String STRING_SPACE = " ";
  private static final String STRING_NEWLINE = "\n";
  private static final String STRING_AT = "@";
  private static final String STRING_EQ = "=";
  
  private static final char APO = '\'';
  private static final String STRING_APO = "'";
  private static final char SEMICOLON = ';'; 
  private static final String STRING_SEMICOLON = ";";
  private static final String GO = "GO";
  
  private static final char OPENP = '(';
  private static final String STRING_OPENP = "(";
  private static final char CLOSEP = ')';
  private static final String STRING_CLOSEP = ")";
  
  private final String[] SQLKWD = new String[]{"DECLARE",
                                               "SELECT", "SHOW", "DESCRIBE",                                               
                                               "UPDATE", "INSERT", "DELETE",
                                               "CREATE", "ALTER", "DROP",
                                               "TRUNCATE", "USE",  
                                               "EXEC", "EXECUTE"};
  private HashMap SQLBGN = null;
  
  protected SQLTextParser()
  {
      int i=0;
      SQLBGN = new HashMap();
      Integer dummy = new Integer(9);
      Integer mix = new Integer(0);
      Integer query = new Integer(1);
      Integer ddl = new Integer(3);
      Integer dml = new Integer(2);
      
      for(i=0; i<SQLKWD.length; i++){
          switch(i){
              case 0:  
              SQLBGN.put(SQLKWD[i], dummy);
              break;
              case 1:
              case 2:
              case 3:
              SQLBGN.put(SQLKWD[i], query);
              break;
              case 4:
              case 5:
              case 6:
              SQLBGN.put(SQLKWD[i], dml);
              break;
              case 7:
              case 8:
              case 9:
              case 10:
              case 11:    
              SQLBGN.put(SQLKWD[i], ddl);
              break;
              case 12:
              case 13:    
              SQLBGN.put(SQLKWD[i], mix);
              break;
          }
      }
      
      
  }

  public static SQLTextParser newInstance()
  {
      if (sQLTextParser == null) sQLTextParser = new SQLTextParser();
      return sQLTextParser;
  }


  public String[] parse(String text)
  {
      
      return null;
  }
  
  
  private String[] breakByKeyword(String sqls)
  {  
       Vector vTokens = new Vector();
       StringBuffer buffer = new StringBuffer(); 
       boolean tokenStart = false;
       
       sqls = sqls.trim();
       int length = sqls.length();
       for(int i=0; i<length; i++){
          char c = sqls.charAt(i);
          if(!tokenStart && !Character.isSpaceChar(c) && c==APO){          	
          	buffer.append(c);i++;
          	while( (c=sqls.charAt(i++))!=APO ){
          		buffer.append(c);
          	}
          	if ( c==APO && i<=length) {
          	    vTokens.add(buffer.toString()); 
          	}else{          	    
          	    vTokens.add(sqls);          	   
          	}
          	 buffer.setLength(0);
          }else if (!tokenStart && !Character.isSpaceChar(c) && c==OPENP){
          	buffer.append(c); i++;          	
          	int pCount = 1;
          	while(i<length && pCount > 0 ){
          		c = sqls.charAt(i++);
          		if (c==OPENP){          		    
          		    pCount++;
          		}else if (c == CLOSEP ){          		    
          		    pCount--;
          		} 
          		buffer.append(c);
          	} 
          	i--; 
          	if (pCount == 0 && i <= length ){          		
          	    vTokens.add(buffer.toString());          	    
          	}else{          	    
          	    vTokens.add(sqls);          	   
          	}  
          	 buffer.setLength(0);
          }else if (!tokenStart && Character.isSpaceChar(c)){
          	vTokens.add(STRING_SPACE);
          }else if (!tokenStart && !Character.isSpaceChar(c)){
          	buffer.append(c);
          	tokenStart = true;          	
          }else if (tokenStart && !Character.isSpaceChar(c)){
          	buffer.append(c);          
          }else if (tokenStart && Character.isSpaceChar(c)){
          	tokenStart = false;
          	vTokens.add(buffer.toString());
          	buffer.setLength(0);
          	vTokens.add(STRING_SPACE);          	
          }
       }//end of for loop;
       if ( buffer.length()>0) vTokens.add(buffer.toString());
       Vector vSqls = new Vector();
       Enumeration enum = vTokens.elements();
       String token = null;
       while(enum.hasMoreElements()){
       	   token = (String)enum.nextElement();
       	   if(SQLBGN.get(token.toUpperCase())!=null){
       	   	if(buffer.length()>0){
       	   		vSqls.add(buffer.toString());
       	   		buffer.setLength(0);       	   		
       	   	}
       	   }
       	   buffer.append(token);       	   
       }
       if( buffer.length()>0) vSqls.add(buffer.toString());       
       String[]  ret = new String[vSqls.size()];
       vSqls.copyInto(ret);
       return ret;
  }
  
  private String[] breakBySemiColon(String sqls)
  {
       Vector store = new Vector();
       boolean varcharStart = false;
       int length = sqls.length();
       StringBuffer sb = new StringBuffer(200);
       for(int i=0; i<length; i++){
          char c = sqls.charAt(i);
          if (!varcharStart && c!=APO && c!=SEMICOLON){
          	sb.append(c);
          }else if (!varcharStart && c==APO){          	
          	varcharStart = true;
          	sb.append(c);
          }else if (varcharStart && c==APO){          	
          	varcharStart = false;
          	sb.append(c);
          }else if (!varcharStart && c==SEMICOLON){          	
          	if (sb.length()>0){
          		store.add(sb.toString());
          		sb.setLength(0);
          	}          	
          }else if (varcharStart){
          	sb.append(c);
          }
       }
       if ( sb.length()>0) store.add(sb.toString());
       String[] ret = new String[store.size()];
       store.copyInto(ret);
       return ret;
  }
  
  private SQLTextUnit[] breakByGo(String sqls)
  {
       if (sqls==null) sqls = "";
       sqls = sqls.trim();
       Vector store = new Vector();
       boolean isInVarChar = false;
       int count = 0;      
       StringBuffer sb = new StringBuffer(200);
       int length = sqls.length();
       for(int i=0; i<length; i++)
       {
           char c = sqls.charAt(i);
           if ( c==APO && isInVarChar == false )
           {
               isInVarChar = true;
               sb.append(c);
           }else if ( c==APO && isInVarChar == true ){
               isInVarChar = false;
               sb.append(c);
           }else if ( (c==g || c==G) &&  isInVarChar == false ){
               if ( ((i-1)==-1 || Character.isSpaceChar(sqls.charAt(i-1)))
                    && (i+1)<length && (sqls.charAt(i+1)==o || sqls.charAt(i+1)==O ) 
                    && ( (i+2)==length || Character.isSpaceChar(sqls.charAt(i+1))) )
               {
                      String text = sb.toString();
                      text = text.trim();
                      int size = text.length();
                      if ( size > 0 ){
                          SQLTextUnit unit = new SQLTextUnit();
                          unit.setText(text);
                          unit.setTextType(textType(text));
                          unit.setParameterCount(count);
                          store.addElement(unit);
                      }
                       sb.setLength(0);
                       count = 0;
                       i = i + 2;
               }
           }else if (c==QUESTIONMARK && isInVarChar == false){
               count++;
               sb.append(c);
           }else{
               sb.append(c);
           }           
       }
      
       SQLTextUnit[] ret = new SQLTextUnit[store.size()];
       store.copyInto(ret);
       return ret;
  }
  
 
  protected int textType(String sql)
  {
      int index = sql.indexOf(STRING_SPACE);
      if (index == -1 ){
          index = sql.indexOf(STRING_NEWLINE);
      }
      String firstWord = sql;
      if (index!=-1){
          firstWord = sql.substring(0, index);
      }
      firstWord = firstWord.toUpperCase();
      Integer type = (Integer)SQLBGN.get(firstWord);
     
      if (type!=null) {
          if (type.intValue()== 9){
              if (hasQuery(sql)) return SQLTextUnit.QUERY;
              return SQLTextUnit.DML;
          }else{
              return type.intValue();
          }
      }
      return SQLTextUnit.MIX;
  }
  
  public boolean hasQuery(String sql)
  {
      String text = sql.toLowerCase();
      int index = text.indexOf(SQLKWD[2]);
      boolean hasquery = false;
      while ( index != -1 ){
          int ATindex = text.indexOf(STRING_AT, index + 6);
          int EQIndex = text.indexOf(STRING_EQ, index + 6);
          int Frindex = text.indexOf("FROM", index + 6);          
          if ( ATindex !=-1  && EQIndex > ATindex && EQIndex < Frindex){             
              index = text.indexOf(SQLKWD[2], Frindex + 4);              
          } else if (ATindex !=-1 &&  EQIndex > ATindex && Frindex != -1 ){
              index = text.indexOf(SQLKWD[2], EQIndex + 1); 
          }else {
              hasquery = true;
              index = -1;
          }
      }
      return hasquery;
  }
  

  public static void main(String[] args)
  {
    SQLTextParser sQLTextParser1 = new SQLTextParser();
    String test="SELECT ('preFix go ' || name) AS name, ('preFix go ' || name) AS name FROM MXBE..TEST WHERE ID NOT IN (SELECT ID FROM XYZ WHERE X=YYY) go ";
    	   test+="SELECT ('pre;Fix' || name) AS name FROM MXBE..TEST WHERE ID NOT IN (SELECT ID FROM XYZ WHERE X=YYY) go ";
    	   test+=" INSERT INTO ('preFix' || name) AS name FROM MXBE..TEST WHERE ID NOT IN (SELECT ID FROM XYZ WHERE X=YYY)";
   	
   	String[] tokens = sQLTextParser1.breakByKeyword(test);
    	printStringArray(tokens);
    
  }
  
  private static void printStringArray(Vector strs)
  {
  	Object[] objs = new Object[strs.size()];
  	strs.copyInto(objs);
  	printStringArray(objs);
  
  }
  private static void printStringArray(Object[] strs){
  	for(int i=0; i<strs.length; i++){
  		System.out.println(strs[i]);
  		System.out.println("-------------------------------------------------------------");
  	}
  
  }
}