package com.gonetix.swing.sql.base;

import java.util.*;
import javax.swing.tree.TreeNode;
import javax.swing.tree.DefaultMutableTreeNode;

public final class ViewNode extends TableNode 
{
  private TableViewInfo tableInfo;
  private String name;
  
  
  public ViewNode(String name)
  {
        super(name);             
        this.name = name;
  }
  
  public String getCatalog()
  {
      if (tableInfo!=null) return tableInfo.getCatalogName();
      return null;
  }

  public String getSchema()
  {
     if (tableInfo!=null) return tableInfo.getSchemaName();
      return null;
  }

  public String getName()
  {
      return this.name;
  }

  public String getFullQualifyName()
  {
      if (tableInfo!=null) return (tableInfo.getCatalogName() + "." + tableInfo.getSchemaName() + "." + name);
      return this.name;
  }

  public TableViewInfo getTableInfo()
  {
    return tableInfo;
  }

  public void setTableInfo(TableViewInfo newTableInfo)
  {
    tableInfo = newTableInfo;
  }
}