package com.gonetix.swing.sql.swing;

import javax.swing.JOptionPane;
import javax.swing.JDialog;
import javax.swing.JTextField;
import java.beans.*; //Property change stuff

import com.gonetix.swing.sql.util.*;
import com.gonetix.swing.sql.base.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.text.*;


public class AddConnDialog extends JDialog
{
  private String[] labels = {"Connection name:", "JDBC Driver:", "JDBC URL:", "JDBC User:", "JDBC Password:" };
  private String[] descs = {"Database connection identifier", "JDBC Driver", "JDBC URL", "JDBC User", "JDBC Password"};
  private String[] dvrList = {"com.sybase.jdbc2.jdbc.SybDriver", 
  			      "oracle.jdbc.driver.OracleDriver", 
  			      "com.mysql.jdbc.Driver", 
  			      "com.microsoft.jdbc.sqlserver.SQLServerDriver", 
  			      "COM.ibm.db2.jdbc.net.DB2Driver", 
  			      "com.pervasive.jdbc.v2.Driver"};
  			      
  private String[] urlList = {"jdbc:sybase:Tds:localhost:2638", 
  			      "jdbc:oracle:thin:@davew:1521:testdb", 
  			      "jdbc:mysql://[hostname][:port]/[dbname]", 
  			      "jdbc:microsoft:sqlserver://[hostname]:1433", 
  			      "jdbc:db2://[host]:[port]/[database]", 
  			      "jdbc:pervasive://[host]:[port]/[database]"};


  private ConnRootNode root;
  private JTree connTree;
  
  private Container container;
  private ConnInfo connInfo;
  
  private JTextField jtfConn = null;
  private JComboBox jcbDvr = null;
  private JComboBox jtfUrl = null;
  private JPasswordField jpfPwd = null;
  private JTextField jtfUser = null;
  

  
  public AddConnDialog(JTree tree, ConnRootNode root)
  {
      super(); 
      this.setTitle("Add Connection");
      this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
      this.root = root;
      this.connTree = tree;
      container = this.getContentPane();
      container.setLayout(new BorderLayout());
      container.add(createFormPanel(), BorderLayout.CENTER);
      container.add(createButtonPanel(), BorderLayout.SOUTH);
      this.setSize(new Dimension(500, 200));
      
  }


  protected JPanel createFormPanel()
  {
    JPanel  formPanel = new JPanel();    
    formPanel.setLayout(new GridBagLayout());
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.anchor = GridBagConstraints.WEST;
    gbc.insets = new Insets(2, 2, 2, 2);    
    
    JLabel l = new JLabel(labels[0]);
    jtfConn = new JTextField(25);
    int connCount = root.getChildCount();
    jtfConn.setText("Connection" + (connCount+1));
    jtfConn.setToolTipText(descs[0]);
    l.setLabelFor(jtfConn); 
    gbc.gridy = 0;
    gbc.gridx = 0;
    formPanel.add(l, gbc);
    gbc.gridx = 1;
    formPanel.add(jtfConn, gbc);

    l = new JLabel(labels[1]);
    jcbDvr = new JComboBox(dvrList);
    jcbDvr.setEditable(true);
    jcbDvr.setToolTipText(descs[1]);
    l.setLabelFor(jcbDvr); 
    gbc.gridy = 1;
    gbc.gridx = 0;
    formPanel.add(l, gbc);
    gbc.gridx = 1;
    formPanel.add(jcbDvr, gbc);
    
    l = new JLabel(labels[2]);
    jtfUrl = new JComboBox(urlList);
    jtfUrl.setEditable(true);
    jtfUrl.setToolTipText(descs[2]);
    l.setLabelFor(jcbDvr); 
    gbc.gridy = 2;
    gbc.gridx = 0;
    formPanel.add(l, gbc);
    gbc.gridx = 1;
    formPanel.add(jtfUrl, gbc);
    
    l = new JLabel(labels[3]);
    jtfUser = new JTextField(25);
    jtfUser.setToolTipText(descs[3]);
    l.setLabelFor(jcbDvr); 
    gbc.gridy = 3;
    gbc.gridx = 0;
    formPanel.add(l, gbc);
    gbc.gridx = 1;
    formPanel.add(jtfUser, gbc);
    
    l = new JLabel(labels[4]);
    jpfPwd = new JPasswordField(25);
    jpfPwd.setToolTipText(descs[4]);
    l.setLabelFor(jcbDvr); 
    gbc.gridy = 4;
    gbc.gridx = 0;
    formPanel.add(l, gbc);
    gbc.gridx = 1;
    formPanel.add(jpfPwd, gbc);

    return formPanel;
  }

  protected JPanel createButtonPanel()
  {
    JPanel  btnPanel = new JPanel();
    btnPanel.setLayout(new GridLayout(1,3));
    JButton jbt = new JButton("Test Connect");  
    jbt.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent ev) {
        	   ConnInfo info =  getConnInfo();
             if (info!=null){
                  try{
                        DBConnectionFactory.testConnection(info);
                        JOptionPane.showMessageDialog(AddConnDialog.this, "connection successfully.");
                  }catch(Exception ex){
                        JOptionPane.showMessageDialog(AddConnDialog.this, "connection failed",
                                              "connection error",
                                               JOptionPane.ERROR_MESSAGE);
                  }
             }
     	}
     });
    btnPanel.add(jbt);
    
    jbt = new JButton("Add Connection"); 
    jbt.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent ev) {
             ConnInfo info =  getConnInfo();
             if (info!=null){
                 ConnNode cnode = new ConnNode(info);
                 root.add(cnode); 
                 connTree.updateUI();
                 ResourceManager.getResourceManager().add(info);
             }
             AddConnDialog.this.dispose();
     	}
     });
    btnPanel.add(jbt);

    jbt = new JButton("Cancel"); 
    jbt.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent ev) {
        	AddConnDialog.this.dispose();
     	}
     });
    btnPanel.add(jbt);
    return btnPanel;
  }

  protected ConnInfo getConnInfo()
  {
      ConnInfo info = null;
      String name = jtfConn.getText();
      if (name==null || name.length()==0 || !Character.isJavaIdentifierPart(name.charAt(0)))
      {
          JOptionPane.showMessageDialog(this, "Please specifiy valid database connection name.",
                                              "connection error",
                                               JOptionPane.ERROR_MESSAGE);

      }else{
          info = new ConnInfo(name);
          info.setDriver((String)jcbDvr.getSelectedItem());
          info.setUrl((String)jtfUrl.getSelectedItem());
          info.setUser(jtfUser.getText());
          info.setPassword(String.valueOf(jpfPwd.getPassword()));
      }
      return info;
  }  
  
}