package com.gonetix.swing.sql.swing;


import javax.swing.JSplitPane;
import com.gonetix.swing.sql.base.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.text.*;
import com.gonetix.swing.sql.swing.*;
import com.gonetix.swing.EditorComponents.SQLUI.*;

public class ExplorerEditorPane extends JSplitPane 
{
  private SQLLeftPanel leftPane; 
  private SQLEditorPane sqlEditor;
  private JDesktopPane rightPane;
  
  public void dispose()
  {
      JInternalFrame[] frames = rightPane.getAllFrames();
      for(int i=0; i<frames.length; i++){
            frames[i].dispose();
      }
  }
  
  public SQLEditorPane getSQLEditorPane()
  {
      return this.sqlEditor;
  }
  

  public ExplorerEditorPane()
  {
      super(JSplitPane.HORIZONTAL_SPLIT);
      this.setDividerLocation(200);
      leftPane = new SQLLeftPanel();
      rightPane = new JDesktopPane();
      EditorInternalFrame editor =new EditorInternalFrame();
      sqlEditor = editor.getSqlEditor();
      editor.setSize(300, 200);
      try{
          editor.setMaximum(true);
      }catch(Exception ex){
          ;
      }
      editor.setVisible(true);
      rightPane.add(editor);
      rightPane.setSelectedFrame(editor);      
      this.setTopComponent(leftPane);
      this.setBottomComponent(rightPane);
  }

  public static void main(String[] args)
  {
        JFrame mainFrame = new JFrame("SQL Explorer");
        mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        ExplorerEditorPane sqlp = new ExplorerEditorPane();
        mainFrame.getContentPane().add(sqlp);        
        mainFrame.setSize(800, 600);
        mainFrame.setVisible(true);
  }
}