package com.gonetix.swing.sql.swing;

import com.gonetix.swing.sql.base.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.text.*;

public class SQLLeftPanel extends JPanel
{
  private JTabbedPane tabbedPane;
  private DBExplorerPane explorerPane;
  private TablePropertiesPane propertiesPane;
  
  public SQLLeftPanel()
  {
    super();
    tabbedPane = new JTabbedPane(JTabbedPane.BOTTOM);
    this.setLayout(new BorderLayout());
    this.add(tabbedPane, BorderLayout.CENTER);
    initPanel();
  }


  protected void initPanel()
  {
      explorerPane = new DBExplorerPane(tabbedPane); 
      propertiesPane = new TablePropertiesPane();
      explorerPane.setTablePropertiesPane(propertiesPane);
      tabbedPane.addTab("Explorer", explorerPane);
      tabbedPane.addTab("Properties", propertiesPane);
  }

  


  public static void main(String[] args)
  {
        JFrame mainFrame = new JFrame("SQL Explorer");
        mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        SQLLeftPanel sqlp = new SQLLeftPanel();
        mainFrame.getContentPane().add(sqlp);        
        mainFrame.setSize(300, 500);
        mainFrame.setVisible(true);
  }
  
}