package com.gonetix.swing.sql.swing;

import javax.swing.JPanel;
import java.util.*;
import java.sql.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

import com.gonetix.swing.sql.util.*;
import com.gonetix.swing.sql.base.*;
import javax.swing.tree.*;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.event.*;
import com.gonetix.swing.EditorComponents.SQLUI.*;


public class SQLWizardPane extends JPanel 
{
  private final String kwLblText = "SQL Keyword";
  private final String fnLblText = "SQL Function";
  private final String opLblText = "SQL Operator";
  
  private final static String[] KEYWORD = {"SELECT", "DISTINCT", "INSERT INTO",  "UPDATE",
                                           "DELETE", "FROM",  "WHERE", "SET",
                                           "ORDER BY", "DESC", "ASC", "VALUES",                                           
                                           "DECLARE", "JOIN", "ON", "CREATE",
                                           "TABLE",   "DROP",  "NOT",  "IN",
                                           "LIKE",  "BETWEEN",  "INDEX",  "PROCEDURE",
                                           "INTO",  "GROUP BY",  "HAVING"};
  private final static String[] OPERATOR = {"*",  ">=",  ">", "<=",  "<",  "<>",
                                           "=", "%", "/", "+", "-", "(", ")"};
 private final static String[] FUNCTION = {"SUM", 
                                           "COUNT", 
                                           "MIN",
                                           "MAX"};

  private JList kwList = null;
  private JList opList = null;
  private JList fnList = null;
  private SQLEditorPane sqlEditor = null;
  
  public SQLWizardPane()
  {
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public void setSqlEditor(SQLEditorPane sqlEditor)
  {
        this.sqlEditor = sqlEditor;
  }

  private void jbInit() throws Exception
  {
    this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));

    Font listFont = new Font("SansSerif", Font.BOLD, 12);
    kwList = new JList(KEYWORD); 
    kwList.setFont(listFont);
    kwList.setBorder(BorderFactory.createEmptyBorder(5,10,5,10));
    kwList.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
    kwList.addMouseListener(new MouseAdapter() {
        public void mouseClicked(MouseEvent e) {
            if (e.getClickCount() == 2) {
                if (sqlEditor!=null){
                   
                }
            }
        }
    });
    JScrollPane listScroller = new JScrollPane(kwList);
    listScroller.setPreferredSize(new Dimension(200, 80));    
    listScroller.setMinimumSize(new Dimension(200, 80));
    listScroller.setAlignmentX(LEFT_ALIGNMENT);
    JPanel listPane = new JPanel();
    listPane.setLayout(new BoxLayout(listPane, BoxLayout.Y_AXIS));
    JLabel label = new JLabel(kwLblText);
    label.setLabelFor(kwList);
    listPane.add(label);
    listPane.add(Box.createRigidArea(new Dimension(0,5)));
    listPane.add(listScroller);
    listPane.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    this.add(listPane);
    
    fnList =  new JList(FUNCTION);
    fnList.setBorder(BorderFactory.createEmptyBorder(5,10,5,10));
    fnList.setFont(listFont);
    fnList.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
    fnList.addMouseListener(new MouseAdapter() {
        public void mouseClicked(MouseEvent e) {
            if (e.getClickCount() == 2) {
                if (sqlEditor!=null){
                   
                }
            }
        }
    });
    listScroller = new JScrollPane(fnList);
    listScroller.setPreferredSize(new Dimension(200, 80));    
    listScroller.setMinimumSize(new Dimension(200, 80));
    listScroller.setAlignmentX(LEFT_ALIGNMENT);
    listPane = new JPanel();
    listPane.setLayout(new BoxLayout(listPane, BoxLayout.Y_AXIS));
    label = new JLabel(fnLblText);
    label.setLabelFor(fnList);
    listPane.add(label);
    listPane.add(Box.createRigidArea(new Dimension(0,5)));
    listPane.add(listScroller);
    listPane.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    this.add(listPane);

    opList = new JList(OPERATOR);
    opList.setBorder(BorderFactory.createEmptyBorder(5,10,5,10));
    opList.setFont(listFont);
    opList.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
    opList.addMouseListener(new MouseAdapter() {
        public void mouseClicked(MouseEvent e) {
            if (e.getClickCount() == 2) {
                
            }
        }
    });
    listScroller = new JScrollPane(opList);
    listScroller.setPreferredSize(new Dimension(200, 80));    
    listScroller.setMinimumSize(new Dimension(200, 80));
    listScroller.setAlignmentX(LEFT_ALIGNMENT);
    listPane = new JPanel();
    listPane.setLayout(new BoxLayout(listPane, BoxLayout.Y_AXIS));
    label = new JLabel(opLblText);
    label.setLabelFor(opList);
    listPane.add(label);
    listPane.add(Box.createRigidArea(new Dimension(0,5)));
    listPane.add(listScroller);
    listPane.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    this.add(listPane);  

    listPane = new JPanel();
    listPane.setLayout(new BoxLayout(listPane, BoxLayout.Y_AXIS));
    JButton button = new JButton("CLEAR");    
    listPane.add(button);
    listPane.add(Box.createRigidArea(new Dimension(0,5)));
    button = new JButton("REPEAT");
    listPane.add(button);
    listPane.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    this.add(listPane);
  }

  public static void main(String[] args) {       
        JFrame f = new JFrame("SQL Wizard");
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                 System.exit(0);
            }
        });        
        f.setContentPane(new SQLWizardPane());
        f.pack();
        f.setVisible(true);
    }

}