package com.gonetix.swing.sql.swing;

import java.beans.*; //Property change stuff

import com.gonetix.swing.sql.base.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.text.*;


public final class TablePropertiesPane extends JPanel
{
  private final Object[] colHeaders ={"Column Name", "Column Type", "Is Null", "Size"};
  private final Object[] propHeaders ={"Property", "Value"};
  
  public TablePropertiesPane()
  {
    super();
    this.setLayout(new BorderLayout());
  }

  public void addTable(TableViewInfo tableInfo)
  {
      JTable table = new JTable(tableInfo.getTableInfo(), colHeaders);
      JScrollPane scrollPane = new JScrollPane(table);
      this.removeAll();
      this.add(scrollPane, BorderLayout.CENTER);      
  }

  public void addTable(Object[][] objs)
  {
      JTable table = new JTable(objs,propHeaders);
      JScrollPane scrollPane = new JScrollPane(table);
      this.removeAll();
      this.add(scrollPane, BorderLayout.CENTER);      
  }

  public static void main(String[] args)
  {
        JFrame mainFrame = new JFrame("SQL Explorer");
        mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        TablePropertiesPane tbPane = new TablePropertiesPane();
        mainFrame.getContentPane().add(tbPane);        
        mainFrame.setSize(300, 500);
        mainFrame.setVisible(true);
  }
  
}