package com.gonetix.swing.sql.util;

import java.util.*;
import com.gonetix.swing.sql.*;

import com.gonetix.swing.sql.base.*;
import com.gonetix.swing.sql.swing.*;
import java.io.*;

public final class ResourceManager 
{
  private static ResourceManager resourceManager = null;
  private static final String resourceFileName = ".sqlfront";
  private String userHome = null;
  private Vector connInfos = null;
  
  protected ResourceManager()
  {
      connInfos = new Vector(20);
      userHome = System.getProperty("user.home");
      if (userHome == null ) userHome = ".";
      loadResource();
  }

  public ConnInfo[] getConnInfoes()
  {
      ConnInfo[] ret = new ConnInfo[connInfos.size()];
      connInfos.copyInto(ret);
      return ret;
  }

  public void removeConn(ConnInfo info)
  {
      connInfos.remove(info);
  }

  public static ResourceManager getResourceManager()
  {
        if (resourceManager == null) resourceManager = new ResourceManager();
        return resourceManager;
  }

  public void add(Object obj)
  {
      connInfos.add(obj);
  }
  
  protected void loadResource()
  {
      try{
        File dir = new File(userHome);
        File resourceFile = new File(dir, resourceFileName);
        if (resourceFile.exists() ){
            FileInputStream istream = new FileInputStream(resourceFile);
            ObjectInputStream p = new ObjectInputStream(istream);
            Object obj = null;
            while ((obj = p.readObject())!=null){
                  if (obj instanceof ConnInfo ) connInfos.add(obj);
            }
            p.close();
        }
      }catch(Exception ex){
            ;
      }
  }


  public void saveResource()
  {
      try{
        File dir = new File(userHome);
        File resourceFile = new File(dir, resourceFileName);                  
        FileOutputStream ostream = new FileOutputStream(resourceFile);
        ObjectOutputStream p = new ObjectOutputStream(ostream);
        Enumeration enum = connInfos.elements();             
        while (enum.hasMoreElements()){
              p.writeObject(enum.nextElement());
        }
        p.close();       
      }catch(Exception ex){
            ex.printStackTrace();
      }
  }
  
}