/*
 * CmdLineOptions.java
 *
 * Created on October 7, 2002, 12:29 PM
 */

package com.gonetix.util;

import java.util.*;

/**
 *
 * @author  SLiu
 */
public final class CmdLineOptions extends java.util.Hashtable 
{
    
    /** Creates a new instance of CmdLineOptions */
    protected CmdLineOptions() {
        super();
    }
    
    public String getOption(String key)
    {
        String[] options = (String[])this.get(key);
        if ( options == null || options.length==0) return null;
        return options[0];
    }
    
    public String getOption(String key, String defaultValue)
    {
        String[] options = (String[])this.get(key);
        if ( options == null || options.length==0) return defaultValue;
        return options[0];
    }
    
    public String[] getOptions(String key)
    {
        String[] options = (String[])this.get(key);        
        return options;
    }
    
    public void setOption(String key, String value)
    {
        String[] options = (String[])this.get(key);
        if ( options == null ){
            options = new String[]{value};
            this.put(key, options);
        }else{
            String[] tmp = new String[options.length+1];
            System.arraycopy(options, 0, tmp, 0, options.length);
            tmp[options.length] = value;
            options = tmp;
            this.put(key, options);
            tmp = null;
        }
    }
    
    
    public static CmdLineOptions getCmdLineOptions(String[] args)
    {
        CmdLineOptions options = new CmdLineOptions();
        for(int i=0; i<args.length; i++){
             if ( args[i]!=null && args[i].startsWith("-")){ 
                 String key = args[i].substring(1);
                 while ( ++i<args.length && !args[i].startsWith("-") )
                 {
                     
                     options.setOption(key, args[i]);                 
                 } 
                 --i;
             }
        }         
        return options;
    }    
    
    
}
