package com.gonetix.util;

import java.util.*;
/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class DebugUtil {
	
	private static final String HEADER = "[DEBUG] ";
	private static final String KEY = "[KEY] ";
	private static final String VALUE = " [VALUE] ";
	private static boolean enable = false;
	
	/**
	 * Constructor for DebugUtil.
	 */
	public DebugUtil() 
	{
		super();
	}
	
	
	public static void Assert(boolean expression, String mrg)
	{
		if (!enable) return;
		if ( expression == false ){
			System.out.print(HEADER);
			System.out.println(mrg);
		}
	}
	
	public static void println(String mrg)
	{
		if (!enable) return;
		System.out.print(HEADER);
		System.out.println(mrg);
	}
	
	public static void println(Throwable t)
	{
		if (!enable) return;
		System.out.print(HEADER);
		StackTraceElement[] ste = t.getStackTrace();
		for(int i=0; i<ste.length; i++)
		{
			System.out.println(ste[i].toString());
		}
	}
	
	public static void printlnIf(boolean expression, String mrg)
	{
		if (!enable) return;
		if ( expression ){
			System.out.print(HEADER);
			System.out.println(mrg);
		}
	}
	
	public static void print(String mrg)
	{
		if (!enable) return;
		System.out.print(HEADER);
		System.out.print(mrg);
	}
	
	public static void printIf(boolean expression, String mrg)
	{
		if (!enable) return;
		if ( expression ){
			System.out.print(HEADER);
			System.out.print(mrg);
		}
	}
	
		
	public static void printProperties(Properties prop)
    {
         if (!enable) return;
         System.out.println(HEADER);
         Enumeration enum = prop.propertyNames();
         while ( enum.hasMoreElements()){
            String key = (String)enum.nextElement();
            System.out.println(key + "=" + prop.getProperty(key));
         }
         System.out.println("******************** end of content of Properties *****************");
         
    }
    
    public static void printArray(Object[] objs)
    {
    	if (!enable) return;
    	System.out.println(HEADER);
    	for(int i=0; i<objs.length; i++)
    	{
    		System.out.println(objs[i].toString());	
    	}
    	System.out.println("******************** end of content of Object array *****************");
    }
    
    public static void printArray(long[] array)
    {
    	if (!enable) return;
    	System.out.println(HEADER);
    	for(int i=0; i<array.length; i++)
    	{
    		System.out.println(array[i]);	
    	}
    	System.out.println("****************** end of content of long array ***************");
    }
    
    public static void printArray(int[] array)
    {
    	if (!enable) return;
    	System.out.println(HEADER);
    	for(int i=0; i<array.length; i++)
    	{
    		System.out.println(array[i]);	
    	}
    	System.out.println("****************** end of content of int array ***************");
    }
	
	public static void printArray(double[] array)
    {
    	if (!enable) return;
    	System.out.println(HEADER);
    	for(int i=0; i<array.length; i++)
    	{
    		System.out.println(array[i]);	
    	}
    	System.out.println("****************** end of content of double array ***************");
    }
    
    
    public static void printCollect(Collection col)
    {
    	if (!enable) return;
    	Iterator iter = col.iterator();
    	System.out.println(HEADER);
    	while ( iter.hasNext())
    	{
    		System.out.println(iter.next().toString());
    	}
    	System.out.println("****************** end of content of "+ col.getClass().getName() + " ***************");
    }
    
    public static void printMap(Map map)
    {
    	if (!enable) return;
    	Set set = map.keySet();
    	Iterator iter = set.iterator();
    	System.out.println(HEADER);
    	while ( iter.hasNext())
    	{
    		Object obj = iter.next();
    		System.out.print(KEY);
    		System.out.print(obj.toString());
    		System.out.print(VALUE);
    		System.out.println(map.get(obj).toString());
    	}
    	System.out.println("***************** end of content of "+ map.getClass().getName() + " *************");
    }
    
	/**
	 * Returns the enable.
	 * @return boolean
	 */
	public static boolean isEnable() {
		return enable;
	}

	/**
	 * Sets the enable.
	 * @param enable The enable to set
	 */
	public static void setEnable(boolean enable) {
		DebugUtil.enable = enable;
	}

}
