package com.gonetix.util;


import org.nfunk.jep.*;
import org.nfunk.jep.type.*;

/**
 * @author SLiu
 *
 */
public final class MathEvaluator {

	private JEP myParser;
	
	/**
	 * Constructor for MathEvaluator.
	 */
	public MathEvaluator() 
	{
		myParser = new JEP();
		myParser.initFunTab(); // clear the contents of the function table
		myParser.addStandardFunctions();
		//myParser.setTraverse(true);
	}
	
	
	public void parseExpression(String expression) 
	{
		myParser.initSymTab(); // clear the contents of the symbol table
		myParser.addStandardConstants();
		myParser.addComplex(); // among other things adds i to the symbol table
		myParser.addVariable("x", 10);
		myParser.parseExpression(expression);
	}
	
	
	
	public double getResult()
	{
		double value = 0.0;
		if ( myParser.getErrorInfo() !=null)
		{
			throw new RuntimeException(myParser.getErrorInfo());	
		}else{
			value = myParser.getValue();
		}
		
		return value;
	}
	
	
	

}
