package com.gonetix.util;


/**
 * @author SLiu
 *
 * This is a wrapper class, it make java method be able to return multiple 
 * value
 */
public final class ParametersRef {

	private Object[] holder = null;
	private int pos = 0;
	private int capacity = 0;
	
	/**
	 * Constructor for ParametersRef.
	 */
	public ParametersRef(int capacity) 
	{
		this.capacity = capacity;
		holder = new Object[capacity];
	}
	
	
	public void addObject(Object object)
	{
		holder[pos++] = object;
	}
	
	
	public void addInt(int value)
	{
		holder[pos++] = new Integer(value);
	}
	
	public void addLong(long value)
	{
		holder[pos++] = new Long(value);
	}
	
	public void addDouble(double value)
	{
		holder[pos++] = new Double(value);
	}
	
	
	/**
	 * Method addObject. 
	 * @param object
	 * @param index
	 */
	public void addObject(Object object, int index)
	{
		holder[index] = object;
	}
	
	
	/**
	 * Method addInt.
	 * @param value
	 * @param index
	 */
	public void addInt(int value, int index)
	{
		holder[index] = new Integer(value);
	}
	
	/**
	 * Method addLong.
	 * @param value
	 * @param index
	 */
	public void addLong(long value, int index)
	{
		holder[index] = new Long(value);
	}
	
	
	/**
	 * Method addDouble.
	 * @param value
	 * @param index
	 */
	public void addDouble(double value, int index)
	{
		holder[index] = new Double(value);
	}
	
	
	/**
	 * Method getObject.
	 * @param index
	 * @return Object
	 */
	public Object getObject(int index)
	{
		return holder[index];
	}	
	
	/**
	 * Method getInt.
	 * @param index
	 * @return int
	 */
	public int getInt(int index)
	{		
		return ((Integer)holder[index]).intValue();
	}
	
	/**
	 * Method getLong.
	 * @param index
	 * @return long
	 */
	public long getLong(int index)
	{
		return ((Long)holder[index]).longValue();
	}
	
	/**
	 * Method getDouble.
	 * @param index
	 * @return double
	 */
	public double getDouble(int index)
	{
		return ((Double)holder[index]).doubleValue();
	}
	
	/**
	 * Method getString.
	 * @param index
	 * @return String
	 */
	public String getString(int index)
	{
		return holder[index].toString();
	}
	
	
	/**
	 * Method capacity.
	 * @return int
	 */
	public int capacity()
	{
		return this.holder.length;	
	}
	
	/**
	 * @see java.lang.Object#finalize()
	 */
	public void finalize()
	{
		this.holder = null;
	}
	
	
	public void reset()
	{
		holder = new Object[capacity];
	}

}
