/*
 * StringFormater.java
 *
 * Created on October 7, 2002, 1:17 PM
 */

package com.gonetix.util;

import java.util.Vector;

/**
 * 
 *
 * This class is clone of C# StringFormater
 * 
 * example:
 * 
 * 	String result = StringFormater.format("Test formater {0} {1} {0}.", new String[]{"Test1", "Test2"});	
 * 	System.out.println(result);
 * 
 * Output:
 * 
 * 	Test formater Test1 Test2 Test1.
 *
 * @author  SLiu
 */
public class StringFormater 
{
   public static String format(String pattern, Object[] replacements)
   {
        Vector v = new Vector(20);
        Variable[] vars = StringParser.parserPattern(pattern, v);
        String[] tokens = new String[v.size()];
        v.copyInto(tokens);
        int i=0;
        for(i=0; i<vars.length; i++){
            int arrayIndex = vars[i].arrayIndex;
            String name = vars[i].varName;
            if (StringParser.isPositiveInteger(name)) 
                tokens[arrayIndex] = replacements[Integer.valueOf(name).intValue()].toString();   
            else 
               tokens[arrayIndex] = vars[i].toString();
        }
        StringBuffer buffer = new StringBuffer(100);
        for(i=0; i<tokens.length; i++){
            buffer.append(tokens[i]);
        }
        return buffer.toString();
   }
   
   public static String format(String pattern, Object replacement0)
   {
       Object[] params = new Object[1];
       params[0] = replacement0;
       return (format(pattern, params));
   }
   
   public static String format(String pattern, Object replacement0, Object replacement1)
   {
       Object[] params = new Object[2];
       params[0] = replacement0;
       params[1] = replacement1;
       return (format(pattern, params));
   }
   
   public static String format(String pattern, Object replacement0, Object replacement1, Object replacement2)
   {
       Object[] params = new Object[3];
       params[0] = replacement0;
       params[1] = replacement1;
       params[2] = replacement2;
       return (format(pattern, params));
   }
   
   public static String format(String pattern, Object replacement0, Object replacement1, Object replacement2, Object replacement3)
   {
       Object[] params = new Object[4];
       params[0] = replacement0;
       params[1] = replacement1;
       params[2] = replacement2;
       params[3] = replacement3;
       return (format(pattern, params));
   }
   
   public static String format(String pattern, Object replacement0, Object replacement1, Object replacement2, Object replacement3, Object replacement4)
   {
       Object[] params = new Object[5];
       params[0] = replacement0;
       params[1] = replacement1;
       params[2] = replacement2;
       params[3] = replacement3;
       params[4] = replacement4;
       return (format(pattern, params));
   }
   
   public static String format(String pattern, Object replacement0, Object replacement1, 
   Object replacement2, Object replacement3, Object replacement4, Object replacement5)
   {
       Object[] params = new Object[6];
       params[0] = replacement0;
       params[1] = replacement1;
       params[2] = replacement2;
       params[3] = replacement3;
       params[4] = replacement4;
       params[5] = replacement5;
       return (format(pattern, params));
   }
   
   public static String format(String pattern, Object replacement0, Object replacement1, 
   Object replacement2, Object replacement3, Object replacement4, Object replacement5, 
   Object replacement6)
   {
       Object[] params = new Object[7];
       params[0] = replacement0;
       params[1] = replacement1;
       params[2] = replacement2;
       params[3] = replacement3;
       params[4] = replacement4;
       params[5] = replacement5;
       params[6] = replacement6;
       return (format(pattern, params));
   }
   
   public static String format(String pattern, Object replacement0, Object replacement1, 
   Object replacement2, Object replacement3, Object replacement4, Object replacement5, 
   Object replacement6, Object replacement7)
   {
       Object[] params = new Object[8];
       params[0] = replacement0;
       params[1] = replacement1;
       params[2] = replacement2;
       params[3] = replacement3;
       params[4] = replacement4;
       params[5] = replacement5;
       params[6] = replacement6;
       params[7] = replacement7;
       return (format(pattern, params));
   }
   
   public static String format(String pattern, Object replacement0, Object replacement1, 
   Object replacement2, Object replacement3, Object replacement4, Object replacement5, 
   Object replacement6, Object replacement7, Object replacement8)
   {
       Object[] params = new Object[9];
       params[0] = replacement0;
       params[1] = replacement1;
       params[2] = replacement2;
       params[3] = replacement3;
       params[4] = replacement4;
       params[5] = replacement5;
       params[6] = replacement6;
       params[7] = replacement7;
       params[8] = replacement8;
       return (format(pattern, params));
   }
   
   public static String format(String pattern, Object replacement0, Object replacement1, 
   Object replacement2, Object replacement3, Object replacement4, Object replacement5, 
   Object replacement6, Object replacement7, Object replacement8, Object replacement9)
   {
       Object[] params = new Object[10];
       params[0] = replacement0;
       params[1] = replacement1;
       params[2] = replacement2;
       params[3] = replacement3;
       params[4] = replacement4;
       params[5] = replacement5;
       params[6] = replacement6;
       params[7] = replacement7;
       params[8] = replacement8;
       params[9] = replacement9;
       return (format(pattern, params));
   }
    
}


final class Variable {   
     
    public static final String ROWCOUNT = "ROWCOUNT";
    public static final String DATE = "DATE";
    public static final String DATETIME = "DATETIME";    
    
    public int startIndex = 0;
    public int endIndex = 0;
    public String varName = null;
    public int arrayIndex = 0;
    
    /** Creates a new instance of Variable */
    public Variable(int startIndex) {
        this.startIndex = startIndex;
    }
    
    public void setVarName(String name)
    {
        this.varName = name;
    }
    
    public void setEndIndex(int index)
    {
        this.endIndex = index;
    }
    
    public void setArrayIndex(int index)
    {
        arrayIndex = index;
    }
    
    
    public String toString()
    {
        StringBuffer sb = new StringBuffer(50);
        sb.append("{");
        sb.append(varName);        
        sb.append("}");
        return sb.toString();
    }
    
}


final class StringParser {
    
    private final static char VARBEGIN = '{';
    private final static char VAREND = '}';
    private final static String VARIABLE = "VARIABLE";
     
    public static Variable[] parserPattern(String source, Vector vector)
    {
        if ( source == null ) return null;
        Vector v = new Vector(20);
        boolean isVarStart = false;
        Variable var = null;
        int length = source.length();
        StringBuffer buffer = new StringBuffer(20);
        for(int i=0; i<length; i++){
            char c = source.charAt(i);
            if ( c==VARBEGIN && isVarStart == false){
                vector.addElement(buffer.toString());
                buffer.setLength(0);
                var = new Variable(i);
                var.setArrayIndex(vector.size());
                isVarStart = true;                
            }else if (isVarStart == true && c==VAREND){
                isVarStart = false;
                var.setEndIndex(i);
                var.setVarName(buffer.toString());
                v.addElement(var);
                vector.addElement(VARIABLE);
                var = null;
                buffer.setLength(0);
            }else if (isVarStart == true && c!=VAREND){
                buffer.append(c);
            }else if (isVarStart == false){
                buffer.append(c);                
            }
        }        
        if ( buffer.length() > 0 ) vector.addElement(buffer.toString());
        Variable[] ret =new Variable[ v.size()];
        v.copyInto(ret);
        return ret;
    }
    
    
    public static boolean isPositiveInteger(String source)
    {
        if ( source==null || source.length()==0 || 
        source.indexOf(".")!=-1 || source.indexOf("-")!=-1) 
                                return false;
        try{
            return (Integer.valueOf(source).intValue()>-1);
        }catch(Exception ex){
            return false;
        }        
    }
    
}
