package com.gonetix.util.configuration;


import java.io.*;
import java.util.*;
import java.util.logging.*;
import java.util.regex.*;

/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Configurator {
		
	Logger logger = Logger.getLogger("com.esd.util.conf");
	
	private final String INDENT = "    ";
	private final String USE_DEFAULT = "${USE_DEFAULT}";
	
	private final String regExStart1 = "([^\\$])\\$\\{";	
	private final String regExStart2 = "\\}|^\\$\\{";
	private final String regExEnd = "\\}";
	private final String regExintern = "\\$\\{VARIABLE\\}";
	private final String regExDefault = "\\$\\{DEFAULT\\}";
	
	private final String currDir = ".";
	
	private final String PROMT = "Configurator> ";	
	private final String Q1 = "Please enter questions file : ";
	private final String Q2 = "Please enter template file (mask) list [**] : ";
	private final String Q5 = "Please enter input directory [../server/conf]: ";
	private final String Q3 = "Please enter output directory [../deployment/conf]: ";
	private final String Q4 = "Please enter ${VARIABLE} value [${DEFAULT}]: ";
	
	private final Pattern ddollar = Pattern.compile("\\${2}");
	private final String ddReplacemant = "\\$";
	
	private ConfVariable[] variables = null;
	private String templates = null;
	private String outDir = null;
	private String inDir = null;
	private String qfile = null;
	private Vector files = null;
	private Properties fileMap = null;
	
	private String rootName = null;
	
	/**
	 * Constructor for Configurator.
	 */
	protected Configurator() {
		super();
		files = new Vector();
		fileMap = new Properties();
	}
	
	
	protected void start(String[] args)
	{
		
		while (variables == null || variables.length==0)
		{
			question(Q1);
			qfile = getResponse();
			if (qfile!=null){
				File qf = new File(qfile);
				if (qf.exists() && qf.isFile()){				
					variables = loadQuestions(qfile);
				}else{
					System.out.println("File not found :" + qf.getAbsolutePath());
					qfile = null;
				}
			}			 
		}
		while (inDir == null)
		{
			question(Q5);
			inDir = getResponse();	
			if ( inDir==null || inDir.length()==0 ) inDir = "../server/conf";		 
		}		
		
		while (outDir == null)
		{
			question(Q3);
			outDir = getResponse();
			if (outDir==null || outDir.length()==0 ) outDir = "../deployment/conf";
			if (outDir!=null){
				File f = new File(outDir);		
				if ( f.exists() == false || f.isDirectory() == false){
					boolean ct = f.mkdirs();
					if (!ct){
						 System.out.println("Can not create director :" + f.getAbsolutePath());
						 outDir = null;
					}
				}
			}
		}		
		
		while (templates == null)
		{
			question(Q2);
			templates = getResponse();
			if ( templates ==null || templates.length()==0 ) templates = "**";	
			dir(templates);		 
		}
		
		getVariableValues(variables);
		replaceAll();
		serialize();
		
		System.out.println("******************** Job complete. ********************");
		System.exit(0);
	}
	
	
	protected void startFromStdin(String commandsString)
	{
		BufferedReader reader = null;
		try{
			reader = new BufferedReader(new StringReader(commandsString));			
			loadQuestionFile(readLine(reader));
			locateInDir(readLine(reader));
			locateOutDir(readLine(reader));
			readTemplateMask(readLine(reader));
			getVariableValues(variables, reader);
			
			replaceAll();
			serialize();
		
			System.out.println("******************** Job complete. ********************");
			System.exit(0);
		
		}catch(Exception ex){
			logger.log(Level.WARNING, "Error at process : system standard input.", ex);		
			System.exit(1);
		}
	}
	
	private String readLine(BufferedReader reader) throws IOException
	{
		String line = null;
		while ((line=reader.readLine())!=null && line.startsWith("#"))
		{
			;
		}
		return line;
	}
	
	
	private void loadQuestionFile(String line) throws Exception
	{
		if (line==null || line.length()==0) throw new Exception("Question file is required.");
		File qf = new File(line);
		if (qf.exists() && qf.isFile()){				
			this.qfile = line;
			variables = loadQuestions(line);
			
		}else{
			throw new Exception("File not found :" + qf.getAbsolutePath());			
		}
	}
	
	private void locateInDir(String line) throws Exception
	{
		if (line==null) throw new Exception("You must specify input directory, but you can use empty line to accept default input directory.");
		if (line.length()==0 || USE_DEFAULT.equals(line)) {
			inDir = "../server/conf";
			return;
		}		
		File qf = new File(line);
		if (qf.exists() && qf.isDirectory()){				
			inDir =  line;
		}else{
			throw new Exception("Directory not found :" + qf.getAbsolutePath());			
		}
	}
	
	private void locateOutDir(String line) throws Exception
	{
		if (line==null) throw new Exception("You must specify output directory, but you can use empty line to accept default input directory.");
		if (line.length()==0 || USE_DEFAULT.equals(line)) {
			outDir = "../deployment/conf";
			return;
		}		
		File qf = new File(line);
		if (qf.exists() && qf.isDirectory()){				
			outDir =  line;
		}else{
			throw new Exception("Directory not found :" + qf.getAbsolutePath());			
		}
	}
	
	private void readTemplateMask(String line) throws Exception
	{
		if (line==null) throw new Exception("You must specify template file mask, but you can use empty line to accept default mask[**].");
		if (line.length()==0 || USE_DEFAULT.equals(line)) {
			templates = "**";			
		}else{		
			templates = line;
		}
		dir(templates);
	}
	
	private void getVariableValues(ConfVariable[] vars, BufferedReader reader) throws Exception
	{
		for(int i=0; i<vars.length; i++)
		{
			ConfVariable var =vars[i];
			if (var.getValue()==null || (var.getValue()!=null && var.isDefaultSet()==true))
			{	
				String value = readLine(reader);
				if (value==null) throw new Exception("You have to answer all of questions, but you can use empty line to accept default value if default value has been set.");
				if ((value.length()==0 || USE_DEFAULT.equals(value) ) && var.isDefaultSet() )
				{
					 value = var.getValue();
				}else{
					if (value.length()==0) 
						throw new Exception("You have to set value for " + var.getName());
				}
				var.setValue(value);
			}			
		}
		
	}
	
	
	
	private void serialize()
	{
		
		PrintWriter writer = null;
		if ( this.rootName == null || rootName.length()==0) rootName = "configurator";
		try{
			File f = new File(qfile);
			File of = new File(outDir, f.getName());
			writer = new PrintWriter(new FileWriter(of));
			writer.println("<" + rootName + ">");
			for(int i=0; i<variables.length; i++)
			{
				ConfVariable var =variables[i];
				writer.print(INDENT);
				writer.println("<" + var.getName() + ">");
				String str = var.getQuestion();
				if (str!=null){
					writer.print(INDENT);writer.print(INDENT);
					writer.print("<question>");
					writer.print(str);					
					writer.println("</question>");
				}
				str = var.getValue();
				if (str!=null){
					writer.print(INDENT);writer.print(INDENT);
					writer.print("<default>");
					writer.print(str);					
					writer.println("</default>");
				}				
				writer.print(INDENT);
				writer.println("</" + var.getName() + ">");
			}
			
			writer.println("</" + this.rootName + ">");
		}catch(Exception ex){
			logger.log(Level.WARNING, "Error at serailize : " + qfile, ex);
		
		}finally{
			
			if( writer!=null) try{ writer.close(); }catch(Exception ex1){;}
		}
	}
	
	private void replaceAll()
	{
		Enumeration enum = fileMap.keys();
		while(enum.hasMoreElements()){
			String in = (String)enum.nextElement();
			String out = fileMap.getProperty(in);
			String outf = replace(in, out, variables);
			if(outf!=null) System.out.println(outf);
		}		
	}
	
	
	
	private String replace(String file, String out, ConfVariable[] vars) 
	{
		File outf = null;
		String ret = null;
		try{
			String content = FileUtil.readTextFile(file);
			for(int i=0; i<vars.length; i++)
			{
				ConfVariable var =vars[i];
				String regexp = regExStart1 + var.getName() + regExStart2 + var.getName() + regExEnd;				
				Pattern pattern = Pattern.compile(regexp);
				Matcher m = null;
				while ((m=pattern.matcher(content)).find())
				{	
					ret = out;	
					String mg = m.group();
					//System.out.println(mg);
					if (mg!=null && !mg.startsWith("\\$")){
						mg = mg.charAt(0) + var.getValue();
					}else{
						mg = var.getValue();
					}
					//System.out.println(mg);
					content = m.replaceFirst((mg==null)?"":mg);			
				}
							
			}
			
			content = cleanDoubleDollar(content);
			FileWriter fw = new FileWriter(out);
			fw.write(content);
			fw.flush();
			fw.close();				
		}catch(Exception ex){
			logger.log(Level.WARNING, "Error at file : " + file, ex);
		}	
		return ret;
	}
	
	
	public String cleanDoubleDollar(String content)
	{
		Matcher m = null;
		while ((m=ddollar.matcher(content)).find())
		{						
			content = m.replaceFirst(ddReplacemant);			
		}		
		return content;
	}
	
	
	private void getVariableValues(ConfVariable[] vars)
	{
		for(int i=0; i<vars.length; i++)
		{
			ConfVariable var =vars[i];
			if (var.getValue()==null || (var.getValue()!=null && var.isDefaultSet()==true))
			{
				String question = var.getQuestion();
				if ( question==null ){
					question = Q4.replaceAll(regExintern, var.getName());
				}
				
				if (var.isDefaultSet() ){
					question = question.replaceAll(regExDefault, var.getValue());
				}else{
					question = question.replaceAll(regExDefault, "");
				}
								
				String value = null;
				while (value==null )
				{
					question(question);
					value = getResponse();
					if (var.isDefaultSet() && value== null) value = var.getValue();
				}
				var.setValue(value);
			}
			
		}
		
	}
	
	
	
	private void question(String question)
	{
		System.out.print(PROMT);
		System.out.print(question);		
	}
	
	
	private String getResponse()
	{
		String cmdLine = null;
		byte[] buffer = new byte[2048]; 
		try{                     
            int num = System.in.read(buffer);
            if ( num > 0 ){
                cmdLine = (new String(buffer, 0, num)).trim();               
            	if ( cmdLine.equalsIgnoreCase("quit") || cmdLine.equalsIgnoreCase("q"))
            	{
            		System.exit(0);
            	}
            
            }
          }catch(Exception ex){;}
          
        return cmdLine;			
	}
	

	public static void main(String[] args) 
	{
		byte[] buffer = new byte[1024];
		int length = 0;
		StringBuffer sb = new StringBuffer(5120);		
		try{
			if (System.in.available() > 0 ){
				if((length=System.in.read(buffer))>0)
				{
					sb.append(new String(buffer, 0, length));
				}
			}
		}catch(Exception ex){
			;
		}		
		String input = sb.toString().trim();
		
		Configurator conf = new Configurator();
		if (input.length() > 0 ){
			conf.startFromStdin(input);
		}else{
			conf.start(args);
		}
		
		
	}
	
	
	
	private void dir(String pattern)
	{
		String[] list = pattern.split("\\s*,\\s*|\\s+");
		FileUtil fu = new FileUtil();
		for(int i=0; i<list.length; i++)
		{
			fu.dir(fileMap, new File(inDir), new File(outDir), list[i]);			
		}
	}
	
	
	private ConfVariable[] loadQuestions(String location)
	{
		ConfVariable[] ret = null;
		try{
			VariableReader reader = new VariableReader();
			reader.setVariableFilePath(location);
			ret = reader.getVariables();
			rootName = reader.getRootName();
		}catch(Exception ex){
			logger.log(Level.WARNING, "Error at load question file." + location, ex);
		}
		return ret;		
	}
	
		
	/**
	 * Sets the outDir.
	 * @param outDir The outDir to set
	 */
	public void setOutDir(String outDir) {
		this.outDir = outDir;
	}

	/**
	 * Returns the inDir.
	 * @return String
	 */
	public String getInDir() {
		return inDir;
	}

	/**
	 * Returns the outDir.
	 * @return String
	 */
	public String getOutDir() {
		return outDir;
	}

	/**
	 * Returns the qfile.
	 * @return String
	 */
	public String getQfile() {
		return qfile;
	}

	/**
	 * Returns the templates.
	 * @return String
	 */
	public String getTemplates() {
		return templates;
	}

	/**
	 * Sets the inDir.
	 * @param inDir The inDir to set
	 */
	public void setInDir(String inDir) {
		this.inDir = inDir;
	}

	/**
	 * Sets the qfile.
	 * @param qfile The qfile to set
	 */
	public void setQfile(String qfile) {
		this.qfile = qfile;
	}

	/**
	 * Sets the templates.
	 * @param templates The templates to set
	 */
	public void setTemplates(String templates) {
		this.templates = templates;
	}

}
