/*
 * FileMaskFilter.java
 *
 * Created on September 26, 2002, 10:47 AM
 */

package com.gonetix.util.configuration;

import java.util.regex.*;
/**
 *
 * @author  SLiu
 */
public final class FileMaskFilter implements java.io.FilenameFilter
{
    private String mask = null;
    /** Creates a new instance of FileMaskFilter */
    public FileMaskFilter(String mask1) 
    {
       
        StringBuffer buffer = new StringBuffer(128);
        for(int i=0; i<mask1.length(); i++){
            char c = mask1.charAt(i);
            if ( c=='*' ) buffer.append(".*");
            else if ( c=='?') buffer.append(".");
            else if ( c=='.') buffer.append("\\.");
            else buffer.append(c);
        }
        this.mask = buffer.toString();       
    }
    
    public boolean accept(java.io.File file, String str) 
    {        
        return Pattern.matches(mask, str);
    }
    
    public String toString()
    {
        return mask;
    }
    
	/**
	 * Returns the mask.
	 * @return String
	 */
	public String getMask() {
		return mask;
	}

}
