package com.gonetix.util.configuration;

import java.util.regex.Pattern;
import java.io.*;
import java.util.*;

/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class FileUtil 
{
	
	/**
	 * Method isWindowsPlatform.
	 * @return boolean
	 */
	public static boolean isWindowsPlatform()
	{
		return (System.getProperty("file.separator").equals("\\"));
	}
	
	/**
	 * Method getAbsolutePath.
	 * @param parent
	 * @param child
	 * @return String
	 */
	public static String getAbsolutePath(String parent, String child)
	{
		child = child.trim();
		if (child.startsWith("/") || child.indexOf(":")!=-1)
		{
			 //it is absoluted path already;
		}else{
			File dir = new File(parent);
			File childf = new File(dir, child);
			try{
				child = childf.getCanonicalPath();
			}catch(IOException ex){
				child = childf.getAbsolutePath();
			}		
		}
		return child;
	}
	
	
	public void dir(Properties prop, File inStartDir, File oStartDir, String mask)
	{
		mask = mask.replace('\\', '/');
		String[] paths = mask.split("/");
		
		File wdf = inStartDir;
		File odf = oStartDir;
				
		for(int i=0; i<paths.length; i++)
		{
			String path = paths[i];
			if (i!=(paths.length-1)){
				if (path.equals("**"))
				{					
					File[] fs = listAllDir(wdf, odf, "*");
					searchChildren(prop, oStartDir, rebuildPath(paths, i+1), fs);
														
				}else if (path.indexOf("*")!=-1 || path.indexOf("?")!=-1){
					File[] fs = listAllDir(wdf, odf, path);
					searchChildren(prop, oStartDir, rebuildPath(paths, i+1), fs);										
				}else{
					wdf = new File(wdf, path);
					if ( wdf.exists() == false || wdf.isDirectory()==false)
					 		throw new PathNotFoundException("Path not found : " + wdf.getAbsolutePath());
					odf = FileUtil.createNotExists(odf.getAbsolutePath(), path);					
				}
			}else{
				if (path.equals("**"))
				{
					listAll(prop, wdf, odf);									
				}else if (path.indexOf("*")!=-1 || path.indexOf("?")!=-1){
					listAllFile(prop, wdf, odf,path);					
				}else{
					File in = new File(wdf, path);
					if ( in.exists() == false || in.isFile()==false)
					 		throw new PathNotFoundException("File not found : " + in.getAbsolutePath());	
					File out = new File(odf, path);
					prop.setProperty(in.getAbsolutePath(), out.getAbsolutePath());		
				}
			}
		}
	}
	
	
	private void searchChildren(Properties prop, File oStartDir, String mask, File[] children)
	{
		String[] paths = mask.split("/");
		for(int i=0; i<children.length; i++){
			File child = children[i];
			File of = new File(oStartDir, child.getName());			
			if ( paths.length == 1){
				if (of.exists()==false || of.isDirectory()==false){
					of.mkdir();
				}
				if (paths[0].indexOf("*")!=-1 || paths[0].indexOf("?")!=-1){					
					listAllFile(prop, child, of, paths[0]);
				}else{
					File in = new File(child, paths[0]);
					File out = new File(of, paths[0]);
					prop.setProperty(in.getAbsolutePath(), out.getAbsolutePath());					
				}							
			}else if (paths.length>1) {			
				if (paths[0].equals(child.getName())){
					if (of.exists()==false || of.isDirectory()==false){
						of.mkdir();
					}
					child = new File(child, paths[0]);
					of = new File(of, paths[0]);
					if (of.exists()==false || of.isDirectory()==false){
						of.mkdir();
					}
					dir(prop, child, of, rebuildPath(paths, 1));					
				}				
			}		
			
		}		
	}
	
	private  String rebuildPath(String[] paths, int startIndex)
	{
		if (  startIndex >= paths.length) return null;
		StringBuffer buffer = new StringBuffer(256);
		for(int i=startIndex; i<paths.length; i++){
			buffer.append(paths[i]);
			if (i!=(paths.length-1)) buffer.append("/");
		}
		return buffer.toString();
	}
	
	
	
	private void listAll(Properties prop, File inStartDir, File oStartDir)
	{
		
		File[] fl = inStartDir.listFiles();
		for(int j=0; j<fl.length; j++)
		{
			File of = new File(oStartDir, fl[j].getName());
			if ( fl[j].isFile()){				
				prop.setProperty(fl[j].getAbsolutePath(), of.getAbsolutePath());				
			}else if (fl[j].isDirectory()){
				if (of.exists()==false || of.isDirectory()==false){
					of.mkdir();
				}
				listAll(prop, fl[j], of);
			}			
		}		
	}
	
	private File[] listAllDir(File inStartDir, File oStartDir, String mask)
	{
		Vector v = new Vector();
		File[] fl = inStartDir.listFiles(new FileMaskFilter(mask));
		for(int j=0; j<fl.length; j++)
		{
			File of = new File(oStartDir, fl[j].getName());
			if ( fl[j].isDirectory()){				
				if (of.exists()==false || of.isDirectory()==false){
					of.mkdir();
				}
				v.addElement(fl[j]);			
			}		
		}
		fl = new File[v.size()];
		v.copyInto(fl);		
		return fl;		
	}
	
	private void listAllFile(Properties prop, File inStartDir, File oStartDir, String mask)
	{
		
		File[] fl = inStartDir.listFiles(new FileMaskFilter(mask));
		if ( fl==null ) return;
		for(int j=0; j<fl.length; j++)
		{
			File of = new File(oStartDir, fl[j].getName());
			if ( fl[j].isFile()){				
				prop.setProperty(fl[j].getAbsolutePath(), of.getAbsolutePath());				
			}		
		}		
	}
	
	
	
	public static File[] getDirectoryList(String parent, String mask)
	{		
		File f = new File(parent);
		File[] ret = f.listFiles(new FileMaskFilter(mask));
		return ret;		
	}
	
	public static File createNotExists(String parent, String child)
	{
		File f = new File(parent);
		File f2 = new File(f, child);
		if (f2.exists()==false || f2.isDirectory() == false )
		{
			boolean b = f2.mkdir();	
		}
		return f2;		
	}	
	
	
	public static String readTextFile(String file) throws IOException
	{
		StringWriter sw = new StringWriter(2048);
		PrintWriter pw = new PrintWriter(sw);
		BufferedReader reader = null;
				
		reader = new BufferedReader(new FileReader(file));
		String line = null;
		while((line=reader.readLine())!=null)
		{
			pw.println(line);
			pw.flush();
		}
		pw.close();
		reader.close();
		return sw.toString();
	}
		
	
}
