package com.gonetix.util.configuration;


import javax.xml.parsers.*;
import org.w3c.dom.*;


/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public final class VariableReader {

	
	private String variableFilePath = null;
	private String rootName = null;
	
	private java.util.Vector variables = null;
	/**
	 * Constructor for VariableReader.
	 */
	public VariableReader() {
		super();
		variables =new java.util.Vector();
	}

	/**
	 * Returns the variableFile.
	 * @return String
	 */
	public String getVariableFilePath() {
		return variableFilePath;
	}

	/**
	 * Sets the variableFile.
	 * @param variableFile The variableFile to set
	 */
	public void setVariableFilePath(String variableFilePath) {
		this.variableFilePath = variableFilePath;
	}
	
	private void loadVariables() throws Exception
	{
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder = factory.newDocumentBuilder();
		Document doc = builder.parse(this.variableFilePath);
		Element root = doc.getDocumentElement();
		this.rootName = root.getNodeName();
		NodeList nodeList = root.getChildNodes();
		int length = nodeList.getLength();
		for(int i=0; i<length; i++){
			Node node = nodeList.item(i);
			if ( node.getNodeType() == Node.ELEMENT_NODE){
				Element el = (Element)node;				
				ConfVariable variable = new ConfVariable();
				//System.out.println(el.getNodeName());
				variable.setName(el.getNodeName());
				String d = getChildValue(el, "default");
				if(d!=null && d.length()>0){
					variable.setIsDefaultSet(true);
					variable.setValue(d);
				}
				variable.setQuestion(getChildValue(el, "question"));				
				variable.setValue(getChildValue(el, "value"));
				variables.addElement(variable);
			}
		}

	}
	
	private String getChildValue(Element el, String childName)
	{
		NodeList nl = el.getElementsByTagName(childName);
		String ret = null;
		if (nl!=null && nl.getLength()>0){
			int len = nl.getLength();
			for(int i=0; i<len; i++)
			{
				//System.out.println(nl.item(i).getNodeName());
				NodeList cnl = nl.item(i).getChildNodes();
				int clen = cnl.getLength();
				for(int k=0; k<clen; k++)
				{
					if (cnl.item(k).getNodeType() == Node.TEXT_NODE)
					{
						ret = cnl.item(i).getNodeValue();
						break;
					}
				}
			}
		}		
		return ret;
	}
	
	public ConfVariable[] getVariables() throws Exception
	{		
		loadVariables();
		ConfVariable[] ret = new ConfVariable[variables.size()];
		variables.copyInto(ret);
		variables.clear();
		return ret;
	}

	/**
	 * Returns the rootName.
	 * @return String
	 */
	public String getRootName() {
		return rootName;
	}

	/**
	 * Sets the rootName.
	 * @param rootName The rootName to set
	 */
	public void setRootName(String rootName) {
		this.rootName = rootName;
	}

}
