package com.gonetix.xml.parser;

import org.xml.sax.ContentHandler;

import com.gonetix.xml.parser.AbstractChainableHandler;
import java.io.*;
import java.util.*;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.FactoryConfigurationError;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public abstract class AbstractXMLHandler extends AbstractChainableHandler 
{	
	protected XMLReader xmlReader;
	protected String xml_dir = null;	
	
	public AbstractXMLHandler()
    {   
    	xml_dir = ".";            
    }
    
    public String getXmlBaseDir()
    {
    	return this.xml_dir;
    }

    public void parse(String file) throws Exception
    {
        File f = new File(file);
        xml_dir = f.getParent();
        parse(new InputSource(file));
    }
    
    public void parse(Reader reader) throws Exception
    {
        parse(new InputSource(reader));
    }
    public void parse(InputStream byteStream) throws Exception
    {
        parse(new InputSource(byteStream));
    }
    
    public void parse(InputSource source) throws Exception
    {                 
        SAXParserFactory spfactory = SAXParserFactory.newInstance();
        spfactory.setValidating(true);        
        SAXParser saxParser = spfactory.newSAXParser();
        xmlReader = saxParser.getXMLReader();            
        xmlReader.setContentHandler(this);
        xmlReader.setEntityResolver(this);
        xmlReader.setErrorHandler(this);
        xmlReader.parse(source);
    } 
	
	/**
	 * @see com.gonetix.xml.parser.AbstractChainableHandler#setContentHandler(org.xml.sax.ContentHandler)
	 */
	public void setContentHandler(ContentHandler handler) 
	{
		xmlReader.setContentHandler(handler);
	}

}
