package com.gonetix.xml.parser;

/**
 * @author SLiu
 *
 * 
 */


public final class PropertyTreeRoot extends PropertyTreeNode {

	/**
	 * Constructor for PropertyTreeRoot.	
	 */
	public PropertyTreeRoot()
	{
		super("dummy", null);
	}
	 
	
	public String getProperty(String hkey)
	{
		if (hkey==null || hkey.length() == 0 ) 
				throw new InvalidPropertyKeyException("Invalid Property key [" + hkey + "]");
		String[] path = hkey.split(".");
		PropertyTreeNode currNode = this;
		for(int i=0; i<path.length; i++)
		{
			if (currNode==null) break;
			currNode = currNode.getChild(path[i]);
		}
		return (currNode==null)?null:currNode.getValue();	
	}	
		
	/**
	 * Returns the period seperated hirarchical property key .
	 * @return String
	 */	
	public String getKeyPath()
	{
		return null;		
	}
			
	
	/**
	 * Returns String representation of this property node.
	 * @return String
	 */		
	public String toString()
	{
		StringBuffer buffer = new StringBuffer();
		java.util.Iterator iter = children();
		while (iter.hasNext())
		{
			PropertyTreeNode child = (PropertyTreeNode)iter.next();
			buffer.append(child.toString());
		}
		return buffer.toString();		
	}
	
	

}
