package com.gonetix.xml.parser;


import java.io.*;
import java.util.*;
import org.xml.sax.*;
import com.gonetix.properties.RegExProperties;

/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class TxtPropertyHandler 
{
	
	PropertyTreeNode parentNode = null;	
	PropertyTreeNode currNode = null;
	
	/**
	 * Constructor for TxtPropertyHandler.
	 */
	public TxtPropertyHandler(PropertyTreeNode parentNode) {
		this.parentNode = parentNode;
	}
	
	public void load(String elementName, String file) throws IOException
	{
		
		if (elementName!=null && elementName.length()>0){
			currNode = new PropertyTreeNode(elementName, parentNode);
			parentNode.addChild(currNode);
		}else{
			currNode = parentNode;
		}
		if (file!=null && file.length()>0){
			loadFileProperties(file);
		}
				   
	}	
	
	protected void loadFileProperties(String path) throws IOException
	{
		RegExProperties prop = new RegExProperties();
		prop.loadFromPath(path);
		Enumeration enum = prop.keys();
		while (enum.hasMoreElements())
		{
			String key = (String)enum.nextElement();
			String[] paths = key.split("\\.");			
			String value = prop.getProperty(key);			
			PropertyTreeNode pNode = currNode;
			for(int i=0; i<paths.length; i++){
				PropertyTreeNode node = currNode.getChild(paths[i]);
				if (node==null) node = new PropertyTreeNode(paths[i], pNode);
				pNode.addChild(node);
				pNode = node;
			}
			if (pNode!=currNode)pNode.setValue(value);
		}
		prop = null;		
	}
	

}
