package com.gonetix.xml.parser;

import com.gonetix.util.*;
import com.gonetix.xml.parser.AbstractChainableHandler;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

import java.io.*;
import java.util.*;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.FactoryConfigurationError;




/**
 * @author SLiu
 *
 */
public class XMLPropertyParser extends AbstractXMLHandler 
{
	
	protected PropertyTreeNode root = null;
		
	
	public XMLPropertyParser(PropertyTreeNode root)
	{
		this.root = root;
	}
	
	public void parse(String parent, String filepath) throws Exception
    {
        parse(FileUtil.getAbsolutePath(parent, filepath));
    }
    
    public void startElement(String namespaceURI, String localName, String qName, Attributes atts)
    throws SAXException 
    {
      
        XMLPropertyHandler childHandler = new XMLPropertyHandler(this, root);
        childHandler.init(qName, atts);
        setContentHandler(childHandler);
    }     
    
}
