package com.gonetix.xml.parser.automation;

import com.gonetix.automation.*;
import com.gonetix.xml.parser.*;

import java.io.*;
import java.util.*;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.FactoryConfigurationError;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;


/**
 * @author SLiu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class XMLTaskHandler extends AbstractXMLHandler 
{
	private final String PROPERTY_TAG = "property";
	private Task task = null;
	private AbstractXMLHandler parent = null;
	private String tagName = null;
	private PropertyTreeRoot taskPropRoot = null;
	/**
	 * Constructor for XMLTaskHandler.
	 */
	public XMLTaskHandler(AbstractXMLHandler parent, Task task)
	{
		this.task = task;
		this.parent = parent;
		taskPropRoot = new PropertyTreeRoot();
	}
	
	public void init(String tagName, Attributes attrs)
	throws SAXException
	{
		this.tagName = tagName;
		int count = attrs.getLength();
		for(int i=0; i<count; i++)
		{
			String name = attrs.getQName(i);
			String value = attrs.getValue(i);
			if ( name.equals("name")){
			}else if (name.equals("depends")){
				task.addDependent(value.trim());
			}else{
				throw new SAXException("Attribute " + name + " is not allowed in task elements.");
			}
		}
	}
	
	public void startElement(String namespaceURI, String localName, String qName, Attributes atts)
    throws SAXException 
    {
       	if (task.getActionRegistry().isActionDefined(qName)){
       		ActionWrapper aw = task.newAction(qName);       		
       		aw.setActionProperties(taskPropRoot.convert());
       		XMLActionHandler handler = new XMLActionHandler(this, task, aw);
       		this.setContentHandler(handler);       		
       	}else{
       		throw new SAXException("Action " + qName + " is undefined.");       		
       	}       
    }
    
    public void characters(char[] ch, int start, int length)
    throws SAXException 
    {       
       
    
    }
    
    public void endElement(String namespaceURI, String localName, String qName)
    throws SAXException 
    {
            if (qName.equals(tagName)) {
            	setContentHandler(parent);
            }  
    }
    
    public void setContentHandler(ContentHandler handler) 
	{
		
		parent.setContentHandler(handler);
	}
	

}
